//-----------------------------------------------------------------------------
//    Api_2_Tkr_Sevl_1.java
//-----------------------------------------------------------------------------

//-----------------------------------------------------------------------------
//    Package Definition
//-----------------------------------------------------------------------------
package uicc.usim.test.toolkit.api_2_tkr_sevl;

//-----------------------------------------------------------------------------
//    Imports
//-----------------------------------------------------------------------------
import javacard.framework.*;
import uicc.toolkit.*;
import uicc.usim.test.util.* ;

/**
 * Test Area : usim.toolkit...
 *
 * Applet is triggered on Install (Install)
 *
 *
 */

public class Api_2_Tkr_Sevl_1 extends TestToolkitApplet
{

    // Events allowed and tested  
    private static byte MAX_EVENT = 7; // (2 to 6, 10 and 24)    
    private short[] EventList = {(short)EVENT_FORMATTED_SMS_PP_ENV, (short)EVENT_FORMATTED_SMS_PP_UPD, (short)EVENT_UNFORMATTED_SMS_PP_ENV,
                                 (short)EVENT_UNFORMATTED_SMS_PP_UPD, (short)EVENT_UNFORMATTED_SMS_CB, (short)EVENT_MO_SHORT_MESSAGE_CONTROL_BY_SIM,  
                                 (short)EVENT_FORMATTED_SMS_CB}; 
                        
    private static short offset = 3;           
    private short[] MonoEventList = {(short)EVENT_MO_SHORT_MESSAGE_CONTROL_BY_SIM};
      
    /**
     * Constructor of the applet
     */
    public Api_2_Tkr_Sevl_1() {
    }

    /**
     * Method called by the JCRE at the installation of the applet.
     */
    public static void install(byte[] bArray, short bOffset, byte bLength) {
        

        
        // Create a new applet instance.
        Api_2_Tkr_Sevl_1 thisApplet = new Api_2_Tkr_Sevl_1();

        // Register the new applet instance to the JCRE
        thisApplet.register(bArray, (short)(bOffset+1), bArray[bOffset]);

        // Initialise the data of the test applet.
        thisApplet.init();
       
        thisApplet.obReg.setEvent(EVENT_FORMATTED_SMS_PP_ENV);
                                                           
    }


    public void processToolkit(short event)
    {
        
                
        boolean bRes = false;
        byte    bTestCaseNb = (byte)0;

            if (event == EVENT_FORMATTED_SMS_PP_ENV){

            // -----------------------------------------------------------------
            // Test Case 1 :For events ranging from 2 to 6, 10 and 24 the
            //              applet calls :
            //              1 - clearEvent() method   No exception shall be thrown
            //              2 - setEventList() method           No exception shall be thrown
            //              3 - isEventSet() method   Shall return true each time
            //              4 - clearEvent() method   No exception shall be thrown    
            // -----------------------------------------------------------------               
                bTestCaseNb = (byte)1;
                bRes = false;
                
            // -----------------------------------------------------------------
            //              1 - For each event in EventList clearEvent(event)
            //                  No exception shall be thrown
            // -----------------------------------------------------------------
                try {
                    for(short i=0; i < (short)(MAX_EVENT); i++) {                
                        obReg.clearEvent(EventList[i]);
                    }
                bRes = true;
                }
                catch (Exception e) {
                    bRes = false;
                }

            // -----------------------------------------------------------------
            //              2 - setEventList(eventList)
            //                  Offset = 0
            //                  Length = eventList.length
            //                  No exception shall be thrown
            // -----------------------------------------------------------------

                try {
                    obReg.setEventList(EventList, (short) 0, (short) EventList.length);
                }
                catch (Exception e) {
                    bRes = false;
                }

            // -----------------------------------------------------------------
            //              3 - For all events in eventList isEventSet(event)
            //                  Each time shall return true
            // -----------------------------------------------------------------
                for( short i=0; (i < MAX_EVENT) && bRes; i++) {
                    bRes = obReg.isEventSet(EventList[i]);
                }
            
            // -----------------------------------------------------------------
            //              4 - For each event in EventList clearEvent(event)
            //                  No exception shall be thrown
            // -----------------------------------------------------------------
                try {
                    for( short i=0; (i < MAX_EVENT) && bRes; i++) {
                        obReg.clearEvent(EventList[i]);
                    }
                }
                catch (Exception e) {
                    bRes = false;
                }

                reportTestOutcome ( bTestCaseNb, bRes );    


            // -----------------------------------------------------------------
            // Test Case 2 :Registering part of eventList buffer
            // -----------------------------------------------------------------
            
                bTestCaseNb = (byte) 2;    
                bRes = false;

            // -----------------------------------------------------------------
            //              1 - For each event in EventList clearEvent(event)
            //                  No exception shall be thrown
            // -----------------------------------------------------------------
                try {
                    for(short i=0; i < (short)(MAX_EVENT); i++) {   
                        obReg.clearEvent(EventList[i]);
                    }
                    bRes = true;
                }
                catch (Exception e) {
                    bRes = false;
                }


            // -----------------------------------------------------------------
            //              2 - setEventList(eventList)
            //                  Offset > 0
            //                  Length = eventList.length - offset
            //                  No exception shall be thrown
            // -----------------------------------------------------------------
                try {
                    obReg.setEventList(EventList, offset, (short) (MAX_EVENT-offset));
                }
                catch (Exception e) {
                    bRes = false;
                }
            // -----------------------------------------------------------------
            //              3 - For all events in eventList isEventSet(event)
            //                  Each time shall return true for events 
            //                  ranging from offset to offset+length 
            // -----------------------------------------------------------------
                for ( short i=0; (i < offset) && bRes; i++) {
                
                    bRes = !obReg.isEventSet(EventList[i]);
                }

            // -----------------------------------------------------------------
            //              3 - else shall return false
            // -----------------------------------------------------------------
                for( short i = offset;(i < MAX_EVENT) && bRes;i++) {
                
                    bRes = obReg.isEventSet(EventList[i]);
                }

            // -----------------------------------------------------------------
            //              4 - For each event in EventList clearEvent(event)
            //                  No exception shall be thrown
            // -----------------------------------------------------------------
                try {
                    for( short i=0;(i < MAX_EVENT) && bRes;i++) {
                        
                        bRes = false;
                        obReg.clearEvent(EventList[i]);
                        bRes = true;
                    }
                }
                catch (Exception e) {
                    bRes = false;
                }
                
                reportTestOutcome(bTestCaseNb, bRes);


                
            // --------------------------------------------------------------------
            // Test Case 3 : Setting EVENT_MO_SHORT_MESSAGE_CONTROL_BY_SIM  
            // --------------------------------------------------------------------
                                
                bTestCaseNb = (byte)3;              
                try{
                    // No exception shall be thrown  
                    obReg.setEventList(MonoEventList,(short) 0, (short) 1);
                    bRes = true;    
                }
                catch (Exception e) {
                    bRes = false;
                }                   
                reportTestOutcome ( bTestCaseNb, bRes );                        
                    
                    
                    
                    
              
                    
              // ------------------------------------------------------------------------------------------------
              // Test Case 4 : Check applet is triggered by an ENVELOPE (EVENT_MO_SHORT_MESSAGE_CONTROL_BY_SIM)     
              // ------------------------------------------------------------------------------------------------                       
            
                    bTestCaseNb = (byte)4;      
                    bRes = false;   
                    reportTestOutcome ( bTestCaseNb, bRes );            
            }
            if (event == EVENT_MO_SHORT_MESSAGE_CONTROL_BY_SIM){            
            
                    bTestCaseNb = (byte)4;      
                    bRes = true;    
                    reportTestOutcome ( bTestCaseNb, bRes );    
            }           
                
    }

}