//-----------------------------------------------------------------------------
//Package Definition
//-----------------------------------------------------------------------------
package uicc.usim.test.toolkit.api_2_ueh_cpyv;

//-----------------------------------------------------------------------------
//Imports
//-----------------------------------------------------------------------------
import org.etsi.scp.wg3.uicc.jcapi.userinterface.*;
import org.etsi.scp.wg3.uicc.jcapi.userclass.*;
import org._3gpp.ct.wg6.usim.jcapi.userclass.*;


public class Test_Api_2_Ueh_Cpyv extends UiccTestModel {

    static final String CAP_FILE_PATH = "uicc/usim/test/toolkit/api_2_ueh_cpyv";
    static final String CLASS_AID_1 = "A0000000 871005FF FFFFFF89 20010001";
    static final String APPLET_AID_1 = "A0000000 871005FF FFFFFF89 20010102";
                                   
    
    private USimAPITestCardService test;
    APDUResponse response;
    
    
    public Test_Api_2_Ueh_Cpyv() {
        test = USimAPITestCardService.getTheUSimTestCardService();
    }
    
    public boolean run() {
        boolean result = false;
        
        // test script
        test.reset();
        test.terminalProfileSession("1719");
        
        
        // Install package
        test.loadPackage(CAP_FILE_PATH);
          
        // Install Applet
        test.installApplet(CAP_FILE_PATH, CLASS_AID_1, APPLET_AID_1, 
            "800A" + // TLV UICC Toolkit application specific parameters
                "01" +   // V Priority Level
                "00" +   // V Max. number of timers
                "10" +   // V Maximum text length for a menu entry
                "01" +   // V Maximum number of menu entries
                "01" +   // V Id of menu entry 1
                "01" +   // V Position of menu entry 1
                "07" +   // V Install with Maximum number of channels 
                "00" +   // LV Minimum Security Level field
                "00" +   // LV TAR Value(s) 
                "00" );  // V Maximum number of services
        
        test.reset();
        test.terminalProfileSession("1719");
        
        /**********************************************************************/
        /** Testcase 1 . Try to use the copyValue method with                 */ 
        /** destination Buffer                                                */
        /**********************************************************************/      
        
        //Trigger Applet1
        test.sendApdu(  "80C20000 FFD181FC 82028381 06058011" +
                        "2233448B 24400881 55667788 7FF60011" +
                        "29120000 04130270 00000E0D 08000000" +
                        "20010100 00000001 003381C8 01010101" +
                        "01010101 01010101 01010101 01010101" +
                        "01010101 01010101 01010101 01010101" +
                        "01010101 01010101 01010101 01010101" +
                        "01010101 01010101 01010101 01010101" +
                        "01010101 01010101 01010101 01010101" +
                        "01010101 01010101 01010101 01010101" +
                        "01010101 01010101 01010101 01010101" +
                        "01010101 01010101 01010101 01010101" +
                        "01010101 01010101 01010101 01010101" +
                        "01010101 01010101 01010101 01010101" +
                        "01010101 01010101 01010101 01010101" +
                        "01010101 01010101 01010101 01010101" +
                        "01010101");
        /**********************************************************************/
        /** Testcase 2 . Try to use the copyValue method with                 */ 
        /** destinationOffset >= destinationBuffer.length                     */
        /**********************************************************************/      
        
        //Trigger Applet1
        test.envelopeSmsPp( "8B244008 81556677 887FF600 11291200" +
                            "00041302 7000000E 0D080000 00200101" +
                            "00000000 01003381 C8010101 01010101" +
                            "01010101 01010101 01010101 01010101" +
                            "01010101 01010101 01010101 01010101" +
                            "01010101 01010101 01010101 01010101" +
                            "01010101 01010101 01010101 01010101" +
                            "01010101 01010101 01010101 01010101" +
                            "01010101 01010101 01010101 01010101" +
                            "01010101 01010101 01010101 01010101" +
                            "01010101 01010101 01010101 01010101" +
                            "01010101 01010101 01010101 01010101" +
                            "01010101 01010101 01010101 01010101" +
                            "01010101 01010101 01010101 01010101" +
                            "01010101 01010101 01010101 01010101" +
                            "01");
        
        /**********************************************************************/
        /** Testcase 3 . Try to use the copyValue method with                 */ 
        /** destinationOffset < 0                                             */
        /**********************************************************************/      
        
        //Trigger Applet1
        test.envelopeSmsPp( "8B244008 81556677 887FF600 11291200" +
                            "00041302 7000000E 0D080000 00200101" +
                            "00000000 01003381 C8010101 01010101" +
                            "01010101 01010101 01010101 01010101" +
                            "01010101 01010101 01010101 01010101" +
                            "01010101 01010101 01010101 01010101" +
                            "01010101 01010101 01010101 01010101" +
                            "01010101 01010101 01010101 01010101" +
                            "01010101 01010101 01010101 01010101" +
                            "01010101 01010101 01010101 01010101" +
                            "01010101 01010101 01010101 01010101" +
                            "01010101 01010101 01010101 01010101" +
                            "01010101 01010101 01010101 01010101" +
                            "01010101 01010101 01010101 01010101" +
                            "01010101 01010101 01010101 01010101" +
                            "01");
        
        /**********************************************************************/
        /** Testcase 4 . Try to use the copyValue method with                 */ 
        /** destinationLength >= destinationBuffer.length                     */
        /**********************************************************************/      
        
        //Trigger Applet1
        test.envelopeSmsPp( "8B244008 81556677 887FF600 11291200" +
                            "00041302 7000000E 0D080000 00200101" +
                            "00000000 01003381 C8010101 01010101" +
                            "01010101 01010101 01010101 01010101" +
                            "01010101 01010101 01010101 01010101" +
                            "01010101 01010101 01010101 01010101" +
                            "01010101 01010101 01010101 01010101" +
                            "01010101 01010101 01010101 01010101" +
                            "01010101 01010101 01010101 01010101" +
                            "01010101 01010101 01010101 01010101" +
                            "01010101 01010101 01010101 01010101" +
                            "01010101 01010101 01010101 01010101" +
                            "01010101 01010101 01010101 01010101" +
                            "01010101 01010101 01010101 01010101" +
                            "01010101 01010101 01010101 01010101" +
                            "01");
        
        /**********************************************************************/
        /** Testcase 5 . Try to use the copyValue method with                 */ 
        /** destinationOffset+ destLength  > destinationBuffer.length         */
        /**********************************************************************/      
        
        //Trigger Applet1
        test.envelopeSmsPp( "8B244008 81556677 887FF600 11291200" +
                            "00041302 7000000E 0D080000 00200101" +
                            "00000000 01003381 C8010101 01010101" +
                            "01010101 01010101 01010101 01010101" +
                            "01010101 01010101 01010101 01010101" +
                            "01010101 01010101 01010101 01010101" +
                            "01010101 01010101 01010101 01010101" +
                            "01010101 01010101 01010101 01010101" +
                            "01010101 01010101 01010101 01010101" +
                            "01010101 01010101 01010101 01010101" +
                            "01010101 01010101 01010101 01010101" +
                            "01010101 01010101 01010101 01010101" +
                            "01010101 01010101 01010101 01010101" +
                            "01010101 01010101 01010101 01010101" +
                            "01010101 01010101 01010101 01010101" +
                            "01");
        
        /**********************************************************************/
        /** Testcase 6 . Try to use the copyValue method with                 */ 
        /** destinationLength < 0                                             */
        /**********************************************************************/      
        
        //Trigger Applet1
        test.sendApdu(  "80C20000 FFD181FC 82028381 06058011" +
                        "2233448B 24400881 55667788 7FF60011" +
                        "29120000 04130270 00000E0D 08000000" +
                        "20010100 00000001 003381C8 01010101" +
                        "01010101 01010101 01010101 01010101" +
                        "01010101 01010101 01010101 01010101" +
                        "01010101 01010101 01010101 01010101" +
                        "01010101 01010101 01010101 01010101" +
                        "01010101 01010101 01010101 01010101" +
                        "01010101 01010101 01010101 01010101" +
                        "01010101 01010101 01010101 01010101" +
                        "01010101 01010101 01010101 01010101" +
                        "01010101 01010101 01010101 01010101" +
                        "01010101 01010101 01010101 01010101" +
                        "01010101 01010101 01010101 01010101" +
                        "01010101 01010101 01010101 01010101" +
                        "01010101");
        /**********************************************************************/
        /** Testcase 7 . Try to use the copyValue method with                 */ 
        /** destinationOffset >= TLV.length                                   */
        /**********************************************************************/      
        
        //Trigger Applet1
        test.sendApdu(  "80C20000 FFD181FC 82028381 06058011" +
                        "2233448B 24400881 55667788 7FF60011" +
                        "29120000 04130270 00000E0D 08000000" +
                        "20010100 00000001 003381C8 01010101" +
                        "01010101 01010101 01010101 01010101" +
                        "01010101 01010101 01010101 01010101" +
                        "01010101 01010101 01010101 01010101" +
                        "01010101 01010101 01010101 01010101" +
                        "01010101 01010101 01010101 01010101" +
                        "01010101 01010101 01010101 01010101" +
                        "01010101 01010101 01010101 01010101" +
                        "01010101 01010101 01010101 01010101" +
                        "01010101 01010101 01010101 01010101" +
                        "01010101 01010101 01010101 01010101" +
                        "01010101 01010101 01010101 01010101" +
                        "01010101 01010101 01010101 01010101" +
                        "01010101");
        
        /**********************************************************************/
        /** Testcase 8 . Try to use the copyValue method with a null          */ 
        /** valueOffset < 0                                                   */
        /**********************************************************************/      
        
        //Trigger Applet1
        test.sendApdu(  "80C20000 FFD181FC 82028381 06058011" +
                        "2233448B 24400881 55667788 7FF60011" +
                        "29120000 04130270 00000E0D 08000000" +
                        "20010100 00000001 003381C8 01010101" +
                        "01010101 01010101 01010101 01010101" +
                        "01010101 01010101 01010101 01010101" +
                        "01010101 01010101 01010101 01010101" +
                        "01010101 01010101 01010101 01010101" +
                        "01010101 01010101 01010101 01010101" +
                        "01010101 01010101 01010101 01010101" +
                        "01010101 01010101 01010101 01010101" +
                        "01010101 01010101 01010101 01010101" +
                        "01010101 01010101 01010101 01010101" +
                        "01010101 01010101 01010101 01010101" +
                        "01010101 01010101 01010101 01010101" +
                        "01010101 01010101 01010101 01010101" +
                        "01010101");
        
        /**********************************************************************/
        /** Testcase 9 . Try to use the copyValue method with                 */ 
        /** destinationLength >= TLV.length                                   */
        /**********************************************************************/      
        
        //Trigger Applet1
        test.sendApdu(  "80C20000 FFD181FC 82028381 06058011" +
                        "2233448B 24400881 55667788 7FF60011" +
                        "29120000 04130270 00000E0D 08000000" +
                        "20010100 00000001 003381C8 01010101" +
                        "01010101 01010101 01010101 01010101" +
                        "01010101 01010101 01010101 01010101" +
                        "01010101 01010101 01010101 01010101" +
                        "01010101 01010101 01010101 01010101" +
                        "01010101 01010101 01010101 01010101" +
                        "01010101 01010101 01010101 01010101" +
                        "01010101 01010101 01010101 01010101" +
                        "01010101 01010101 01010101 01010101" +
                        "01010101 01010101 01010101 01010101" +
                        "01010101 01010101 01010101 01010101" +
                        "01010101 01010101 01010101 01010101" +
                        "01010101 01010101 01010101 01010101" +
                        "01010101");
        
        /**********************************************************************/
        /** Testcase 10 . Try to use the copyValue method with                */ 
        /** ValueOffset + destinationLength > TLV Length                      */
        /**********************************************************************/      
        
        //Trigger Applet1
        test.sendApdu(  "80C20000 FFD181FC 82028381 06058011" +
                        "2233448B 24400881 55667788 7FF60011" +
                        "29120000 04130270 00000E0D 08000000" +
                        "20010100 00000001 003381C8 01010101" +
                        "01010101 01010101 01010101 01010101" +
                        "01010101 01010101 01010101 01010101" +
                        "01010101 01010101 01010101 01010101" +
                        "01010101 01010101 01010101 01010101" +
                        "01010101 01010101 01010101 01010101" +
                        "01010101 01010101 01010101 01010101" +
                        "01010101 01010101 01010101 01010101" +
                        "01010101 01010101 01010101 01010101" +
                        "01010101 01010101 01010101 01010101" +
                        "01010101 01010101 01010101 01010101" +
                        "01010101 01010101 01010101 01010101" +
                        "01010101 01010101 01010101 01010101" +
                        "01010101");
        
        /**********************************************************************/
        /** Testcase 11 . Try to use the copyValue method with                */ 
        /** Search TLV 01h   UNAVAILABLE_Exception                            */
        /**********************************************************************/      
        
        //Trigger Applet1
        test.sendApdu(  "80C20000 FFD181FC 82028381 06058011" +
                        "2233448B 24400881 55667788 7FF60011" +
                        "29120000 04130270 00000E0D 08000000" +
                        "20010100 00000001 003381C8 01010101" +
                        "01010101 01010101 01010101 01010101" +
                        "01010101 01010101 01010101 01010101" +
                        "01010101 01010101 01010101 01010101" +
                        "01010101 01010101 01010101 01010101" +
                        "01010101 01010101 01010101 01010101" +
                        "01010101 01010101 01010101 01010101" +
                        "01010101 01010101 01010101 01010101" +
                        "01010101 01010101 01010101 01010101" +
                        "01010101 01010101 01010101 01010101" +
                        "01010101 01010101 01010101 01010101" +
                        "01010101 01010101 01010101 01010101" +
                        "01010101 01010101 01010101 01010101" +
                        "01010101");
        
        
        /**********************************************************************/
        /** Testcase 12 . use successfully the copyValue method               */ 
        /**********************************************************************/      
        
        //Trigger Applet1
        test.sendApdu(  "80C20000 FFD181FC 82028381 06068111" +
                        "223344F5 8B244008 81556677 887FF600" +
                        "11291200 00041302 7000000E 0D080000" +
                        "00200101 00000000 01003381 C7010101" +
                        "01010101 01010101 01010101 01010101" +
                        "01010101 01010101 01010101 01010101" +
                        "01010101 01010101 01010101 01010101" +
                        "01010101 01010101 01010101 01010101" +
                        "01010101 01010101 01010101 01010101" +
                        "01010101 01010101 01010101 01010101" +
                        "01010101 01010101 01010101 01010101" +
                        "01010101 01010101 01010101 01010101" +
                        "01010101 01010101 01010101 01010101" +
                        "01010101 01010101 01010101 01010101" +
                        "01010101 01010101 01010101 01010101" +
                        "01010101 01010101 01010101 01010101" +
                        "01010101");
        
        
        /**********************************************************************/
        /** Testcase 13 . use successfully the copyValue method               */ 
        /**********************************************************************/      
        
        //Trigger Applet1  
        test.sendApdu(  "80C20000 FFD181FC 82028381 06068111" +
                        "223344F5 8B244008 81556677 887FF600" +
                        "11291200 00041302 7000000E 0D080000" +
                        "00200101 00000000 01003381 C7010101" +
                        "01010101 01010101 01010101 01010101" +
                        "01010101 01010101 01010101 01010101" +
                        "01010101 01010101 01010101 01010101" +
                        "01010101 01010101 01010101 01010101" +
                        "01010101 01010101 01010101 01010101" +
                        "01010101 01010101 01010101 01010101" +
                        "01010101 01010101 01010101 01010101" +
                        "01010101 01010101 01010101 01010101" +
                        "01010101 01010101 01010101 01010101" +
                        "01010101 01010101 01010101 01010101" +
                        "01010101 01010101 01010101 01010101" +
                        "01010101 01010101 01010101 01010101" +
                        "01010101");
        
        /**********************************************************************/
        /** Testcase 14 . use successfully the copyValue method               */
        /** initialize dstBuffer dstBuffer = 55 55  55                       */
        /**********************************************************************/      
        
        //Trigger Applet1  
        test.sendApdu(  "80C20000 FFD181FC 82028381 06058011" +
                        "2233448B 24400881 55667788 7FF60011" +
                        "29120000 04130270 00000E0D 08000000" +
                        "20010100 00000001 003381C8 01010101" +
                        "01010101 01010101 01010101 01010101" +
                        "01010101 01010101 01010101 01010101" +
                        "01010101 01010101 01010101 01010101" +
                        "01010101 01010101 01010101 01010101" +
                        "01010101 01010101 01010101 01010101" +
                        "01010101 01010101 01010101 01010101" +
                        "01010101 01010101 01010101 01010101" +
                        "01010101 01010101 01010101 01010101" +
                        "01010101 01010101 01010101 01010101" +
                        "01010101 01010101 01010101 01010101" +
                        "01010101 01010101 01010101 01010101" +
                        "01010101 01010101 01010101 01010101" +
                        "01010101");
        
        /**********************************************************************/
        /** Testcase 15 . use successfully the copyValue method               */
        /** initialize Buffer = 55 55 55 11 22 33 44 55 ... 55                */
        /**********************************************************************/      
        
        //Trigger Applet1  
        test.sendApdu(  "80C20000 FFD181FC 82028381 06058011" +
                        "2233448B 24400881 55667788 7FF60011" +
                        "29120000 04130270 00000E0D 08000000" +
                        "20010100 00000001 003381C8 01010101" +
                        "01010101 01010101 01010101 01010101" +
                        "01010101 01010101 01010101 01010101" +
                        "01010101 01010101 01010101 01010101" +
                        "01010101 01010101 01010101 01010101" +
                        "01010101 01010101 01010101 01010101" +
                        "01010101 01010101 01010101 01010101" +
                        "01010101 01010101 01010101 01010101" +
                        "01010101 01010101 01010101 01010101" +
                        "01010101 01010101 01010101 01010101" +
                        "01010101 01010101 01010101 01010101" +
                        "01010101 01010101 01010101 01010101" +
                        "01010101 01010101 01010101 01010101" +
                        "01010101");
        
        /**********************************************************************/
        /** Testcase 16 . use successfully the copyValue method               */
        /** Successful call, copy with length =0                              */
        /** dstBuffer.length = 20, dstOffset = 20, dstLength = 0              */
        /**********************************************************************/      
        
        //Trigger Applet1  
        test.sendApdu(  "80C20000 FFD181FC 82028381 06068111" +
                        "223344F5 8B244008 81556677 887FF600" +
                        "11291200 00041302 7000000E 0D080000" +
                        "00200101 00000000 01003381 C7010101" +
                        "01010101 01010101 01010101 01010101" +
                        "01010101 01010101 01010101 01010101" +
                        "01010101 01010101 01010101 01010101" +
                        "01010101 01010101 01010101 01010101" +
                        "01010101 01010101 01010101 01010101" +
                        "01010101 01010101 01010101 01010101" +
                        "01010101 01010101 01010101 01010101" +
                        "01010101 01010101 01010101 01010101" +
                        "01010101 01010101 01010101 01010101" +
                        "01010101 01010101 01010101 01010101" +
                        "01010101 01010101 01010101 01010101" +
                        "01010101 01010101 01010101 01010101" +
                        "01010101");
        
        /***********************************/        
        /**         Check results          */        
        /***********************************/         
        
        // Select applet
        response = test.selectApplication(APPLET_AID_1);
        result = response.checkData("10" + APPLET_AID_1 + 
                                    "10CCCCCC CCCCCCCC CCCCCCCC CCCCCCCC" +
                                    "CC");
        
        
        test.reset();
        test.terminalProfileSession("1719");
                                         
        // Delete Applet 
        test.deleteApplet(APPLET_AID_1);
        // Delete Package
        test.deletePackage(CAP_FILE_PATH);   
        
        return result;
    }
}   
