//-----------------------------------------------------------------------------
//Package Definition
//-----------------------------------------------------------------------------
package uicc.usim.test.toolkit.api_2_ueh_find;

//-----------------------------------------------------------------------------
//Imports
//-----------------------------------------------------------------------------
import org.etsi.scp.wg3.uicc.jcapi.userinterface.*;
import org.etsi.scp.wg3.uicc.jcapi.userclass.*;
import org._3gpp.ct.wg6.usim.jcapi.userclass.*;


public class Test_Api_2_Ueh_Find extends UiccTestModel {

    static final String CAP_FILE_PATH = "uicc/usim/test/toolkit/api_2_ueh_Find";
    static final String CLASS_AID_1 = "A0000000 871005FF FFFFFF89 20010001";
    static final String APPLET_AID_1 = "A0000000 871005FF FFFFFF89 20010102";
    
    
    private USimAPITestCardService test;
    APDUResponse response;
    
        
    public Test_Api_2_Ueh_Find() {
        test = USimAPITestCardService.getTheUSimTestCardService();
    }
    
    public boolean run() {
        boolean result = false;
        
        // test script
        test.reset();
        test.terminalProfileSession("1719");
        
        
        // Install package
        test.loadPackage(CAP_FILE_PATH);
            
        // Install Applet
        response = test.installApplet(CAP_FILE_PATH, CLASS_AID_1, APPLET_AID_1, 
            "8008" + // TLV UICC Toolkit application specific parameters
                "01" +   // V Priority Level
                "00" +   // V Max. number of timers
                "00" +   // V Maximum text length for a menu entry
                "00" +   // V Maximum number of menu entries                              
                "07" +   // V Install with Maximum number of channels 
                "00" +   // LV Minimum Security Level field
                "00" +   // LV TAR Value(s) 
                "00" );  // V Maximum number of services
        
        result &= response.checkSw("9000"); 

        test.reset();
        test.terminalProfileSession("1719");
          
        /**********************************************************************/
        /** Testcase 1. Invalid input parameter  findTLV()  Occurrence = 0    */
        /**********************************************************************/      
        //Trigger applet
        test.envelopeSmsPp( "8B244008 81556677 887FF600 11291200" +
                            "00041302 7000000E 0D080000 00200101" +
                            "00000000 01000201 11040533 44556677");
        
        /**********************************************************************/
        /** Testcase 2. Search 1st TLV findTLV() Tag = 02h Occurrence = 1     */
        /**********************************************************************/      
        //Trigger applet
        test.envelopeSmsPp( "8B244008 81556677 887FF600 11291200" +
                            "00041302 7000000E 0D080000 00200101" +
                            "00000000 01000201 11040533 44556677");
        /**********************************************************************/
        /** Testcase 3. Call the getValueLength() method                      */
        /**********************************************************************/      
        //Trigger applet
        test.envelopeSmsPp( "8B244008 81556677 887FF600 11291200" +
                            "00041302 7000000E 0D080000 00200101" +
                            "00000000 01000201 11040533 44556677");
        
        /**********************************************************************/
        /** Testcase 4.  Search 2nd TLV findTLV() Tag = 06h Occurrence = 1    */
        /**********************************************************************/      
        //Trigger applet
        test.sendApdu(  "80C20000 3DD13B82 02838186 05801122" +
                        "33448B24 40088155 6677887F F6001129" +
                        "12000004 13027000 000E0D08 00000020" +
                        "01010000 00000100 02011104 05334455" +
                        "6677");  
        
        /**********************************************************************/
        /** Testcase 5. Call the getValueLength() method                      */
        /**********************************************************************/      
        //Trigger applet
        test.sendApdu(  "80C20000 3DD13B82 02838186 05801122" +
                        "33448B24 40088155 6677887F F6001129" +
                        "12000004 13027000 000E0D08 00000020" +
                        "01010000 00000100 02011104 05334455" +
                        "6677");  
        
        /**********************************************************************/
        /** Testcase 6. Select a TLV (tag 02h)                                */
        /**********************************************************************/      
        //Trigger applet
        test.envelopeSmsPp( "8B244008 81556677 887FF600 11291200" +
                            "00041302 7000000E 0D080000 00200101" +
                            "00000000 01000201 11040533 44556677");
        
        /**********************************************************************/
        /** Testcase 7.  Call the getValueLength() method                     */
        /**********************************************************************/      
        //Trigger applet
        test.envelopeSmsPp( "8B244008 81556677 887FF600 11291200" +
                            "00041302 7000000E 0D080000 00200101" +
                            "00000000 01000201 11040533 44556677");
        
        /**********************************************************************/
        /** Testcase 8.  Search a tag with wrong occurrence findTLV()         */
        /** Tag = 02h Occurrence = 3                                          */
        /**********************************************************************/      
        //Trigger applet
        test.envelopeSmsPp( "8B244008 81556677 887FF600 11291200" +
                            "00041302 7000000E 0D080000 00200101" +
                            "00000000 01000201 11040533 44556677");
        
        /**********************************************************************/
        /** Testcase 9. Call the getValueLength() method                      */
        /**********************************************************************/      
        //Trigger applet
        test.envelopeSmsPp( "8B244008 81556677 887FF600 11291200" +
                            "00041302 7000000E 0D080000 00200101" +
                            "00000000 01000201 11040533 44556677");
        
        /**********************************************************************/
        /** Testcase 10. Search the TLV findTLV() Tag = 02h Occurrence = 2    */
        /**********************************************************************/      
        //Trigger applet
        test.envelopeSmsPp( "8B244008 81556677 887FF600 11291200" +
                            "00041302 7000000E 0D080000 00200101" +
                            "00000000 01000201 11040533 44556677");
        
        /**********************************************************************/
        /** Testcase 11. Search the TLV findTLV() Tag = 04h Occurrence = 1    */
        /**********************************************************************/      
        //Trigger applet
        test.envelopeSmsPp( "8B244008 81556677 887FF600 11291200" +
                            "00041302 7000000E 0D080000 00200101" +
                            "00000000 01000201 11040533 44556677");
        
        /**********************************************************************/
        /** Testcase 12. Search tag 86h findTLV() Tag = 86h Occurrence = 1    */
        /**********************************************************************/      
        //Trigger applet
        test.sendApdu(  "80C20000 3DD13B82 02838186 05801122" +
                        "33448B24 40088155 6677887F F6001129" +
                        "12000004 13027000 000E0D08 00000020" +
                        "01010000 00000100 02011104 05334455" +
                        "6677");
        
        /**********************************************************************/
        /** Testcase 13. Search tag 84h findTLV() Tag = 84h Occurrence = 1    */
        /**********************************************************************/      
        //Trigger applet
        test.envelopeSmsPp( "8B244008 81556677 887FF600 11291200" +
                            "00041302 7000000E 0D080000 00200101" +
                            "00000000 01000201 11040533 44556677");
        
        
        /***********************************/        
        /**         Check results          */        
        /***********************************/         
        
        // Select applet
        response = test.selectApplication(APPLET_AID_1);
        result = response.checkData(    "10" + APPLET_AID_1 + 
                                        "0DCCCCCC CCCCCCCC CCCCCCCC CCCC");
        
        
        test.reset();
        test.terminalProfileSession("1719");
                                           
        // Delete Applet 
        test.deleteApplet(APPLET_AID_1);
        // Delete Package
        test.deletePackage(CAP_FILE_PATH);   
        
        return result;
    }
}   
