//-----------------------------------------------------------------------------
//Api_2_Ueh_Gsml_1.java
//-----------------------------------------------------------------------------

//-----------------------------------------------------------------------------
//Package Definition
//-----------------------------------------------------------------------------
package uicc.usim.test.toolkit.api_2_ueh_gsml;

//-----------------------------------------------------------------------------
//Imports
//-----------------------------------------------------------------------------

import uicc.toolkit.ToolkitException;
import uicc.usim.test.util.* ;
import uicc.usim.toolkit.* ;

/**
* Test Area : uicc.ussim.tookit.USATEnvelopeHandler.getShortMessageLength()
*/

public class Api_2_Ueh_Gsml_1  extends TestToolkitApplet
{
    // Number of tests
    byte testCaseNb = (byte) 0x00;
      
    /**
    * Constructor of the applet
    */
    public Api_2_Ueh_Gsml_1 () 
    {
    
    }
    
    
    /**
    * Method called by the JCRE at the installation of the applet
    */
    public static void install(byte bArray[], short bOffset, byte bLength) 
    {
        // Create a new applet instance
        Api_2_Ueh_Gsml_1  thisApplet = new Api_2_Ueh_Gsml_1 ();
        
        // Register the new applet instance to the JCRE            
        thisApplet.register(bArray, (short)(bOffset+1), bArray[bOffset]);
        
        // Initialise the data of the test applet
        thisApplet.init();  
        
        // Set Formatted SMS PP ENV as an activation event for the applet
        thisApplet.obReg.setEvent(EVENT_FORMATTED_SMS_PP_ENV);
        
        // Set Formatted SMS PP UPD as an activation event for the applet
        thisApplet.obReg.setEvent(EVENT_FORMATTED_SMS_PP_UPD);
          
          // Set Formatted SMS CB as an activation event for the applet
        thisApplet.obReg.setEvent(EVENT_FORMATTED_SMS_CB);
          
          // Set Unformatted SMS CB as an activation event for the applet
        thisApplet.obReg.setEvent(EVENT_UNFORMATTED_SMS_CB);
          
          // Set Unformatted SMS PP as an activation event for the applet
        thisApplet.obReg.setEvent(EVENT_UNFORMATTED_SMS_PP_ENV);
        
        // Set Unformatted SMS UPD as an activation event for the applet
        thisApplet.obReg.setEvent(EVENT_UNFORMATTED_SMS_PP_UPD);

        // Set Unrecognized Envelope as an activation event for the applet
        thisApplet.obReg.setEvent(EVENT_UNRECOGNIZED_ENVELOPE);

    }
    
    
    /**
     * Method called by the SIM Toolkit Framework
    */
    public void processToolkit(short event) 
    {
        // Result of tests
        boolean bRes ;
        
        // Get the system instance of handlers
          USATEnvelopeHandler envHdlr = USATEnvelopeHandlerSystem.getTheHandler();
        
        switch ( testCaseNb ) 
        {
            //=================================================================
            //=========        FORMATTED SMS PP ENV triggering        =========
            //=================================================================
            case (byte) 0 :
            case (byte) 1 :
                // --------------------------------------------
                // Test Case 1-2 : getShortMessageLength with various length of TP-OA:2 and 12
            
                bRes = false ;
                testCaseNb++;
                try {
                    if (envHdlr.getShortMessageLength() == (short)0x003A)
                        bRes = true;
                }
                catch (Exception e)    {    
                    bRes = false ;
                }
                reportTestOutcome(testCaseNb, bRes) ;
                break;
            
            case (byte) 2 :
                // --------------------------------------------
                // Test Case 3 : getShortMessageLength with PCNTR = 0, no RC/CC/DS and data length of 0x10
                bRes = false ;
                testCaseNb = (byte) 3 ;
                try {
                    if (envHdlr.getShortMessageLength() == (short)0x0020)
                        bRes = true;
                }
                catch (Exception e)    {    
                    bRes = false ;
                }
                reportTestOutcome(testCaseNb, bRes) ;
                break;
            
            case (byte) 3 :
                // --------------------------------------------
                // Test Case 4 : Test with PCNTR = 7, no RC/CC/DS and data length of 0x03 
                bRes = false ;
                testCaseNb = (byte) 4 ;
                try {
                    if (envHdlr.getShortMessageLength() == (short)0x001A)
                        bRes = true;
                }
                catch (Exception e)    {    
                    bRes = false ;
                }
                reportTestOutcome(testCaseNb, bRes) ;
                break;
            
            case (byte) 4 :
                // --------------------------------------------
                // Test Case 4 : Test with PCNTR = 0, with RC/CC/DS length of 8 and secured data length of 0x10 
                bRes = false ;
                testCaseNb = (byte) 5 ;
                try {
                    if (envHdlr.getShortMessageLength() == (short)0x0028)
                        bRes = true;
                }
                catch (Exception e)    {    
                    bRes = false ;
                }
                reportTestOutcome(testCaseNb, bRes) ;
                break;
            
            case (byte) 5 :
                // --------------------------------------------
                // Test Case 6 : getShortMessageLength with PCNTR = 0, no RC/CC/DS and SecuredDataLength = 00
                testCaseNb = (byte) 6 ;
            
                bRes = false ;
                try {
                    if (envHdlr.getShortMessageLength() == (short)0x0010)
                        bRes = true;
                }
                catch (Exception e)    {    
                    bRes = false ;
                }
                reportTestOutcome(testCaseNb, bRes) ;
                break;
                
            case (byte) 6 :
                // --------------------------------------------
                // Test Case 7 : Test with PCNTR = 0, no RC/CC/DS and UserDataLength = maximum length (0x8C) for a single SMS
                testCaseNb = (byte) 7 ;
            
                bRes = false ;
                try {
                    if (envHdlr.getShortMessageLength() == (short)0x0089)
                        bRes = true;
                }
                catch (Exception e)    {    
                    bRes = false ;
                }
                reportTestOutcome(testCaseNb, bRes) ;
                break;
            
            case (byte) 7 :
                // --------------------------------------------
                // Test Case 8 : getShortMessageLength with length = 0
                testCaseNb = (byte) 8 ;
            
                bRes = false ;
                try {
                    if (envHdlr.getShortMessageLength() == (short)0x0015)
                        bRes = true;
                }
                catch (Exception e)    {    
                    bRes = false ;
                }
                reportTestOutcome(testCaseNb, bRes) ;
                break;
            case (byte) 8 :
                // --------------------------------------------
                // Test Case 9 : Send envelope SMS-PP Formatted.FindTLV() with TAG_DEVICE_IDENTITIES.
                // getUserDataLength() and then getValueByte() with offset 0 
                testCaseNb = (byte) 9 ;
            
                bRes = false ;
                try {
                    if((envHdlr.findTLV(TAG_DEVICE_IDENTITIES,(byte)1)!=TLV_NOT_FOUND)&&
                        (envHdlr.getShortMessageLength() == (short)0x0015)&&
                        (envHdlr.getValueByte((short)0)==0x40))
                                            bRes = true;
                }
                catch (Exception e)    {    
                    bRes = false ;
                }
                reportTestOutcome(testCaseNb, bRes) ;
                break;
            
            case (byte) 9 :
                // --------------------------------------------
                // Test Case 10 : Test with UserDataLength = maximum length (0x010D) with 2 concatenated SMS 
                testCaseNb = (byte) 10 ;
            
                bRes = false ;
                try {
                    if (envHdlr.getShortMessageLength() == (short)0x010A)
                        bRes = true;
                }
                catch (Exception e)    {    
                    bRes = false ;
                }
                reportTestOutcome(testCaseNb, bRes) ;
                break;
            
            //=================================================================
            //=========        FORMATTED SMS PP UPD triggering        =========
            //=================================================================
            case (byte) 10 :
            case (byte) 11 :
                // --------------------------------------------
                // Test Case 11-12 : getShortMessageLength with various length of TP-OA:2 and 12
                testCaseNb++;
            
                bRes = false ;
                try {
                    if (envHdlr.getShortMessageLength() == (short)0x003A)
                        bRes = true;
                }
                catch (Exception e)    {    
                    bRes = false ;
                }
                reportTestOutcome(testCaseNb, bRes) ;
                break;
            
            case (byte) 12 :
                // --------------------------------------------
                // Test Case 13 : Test with PCNTR = 0, no RC/CC/DS and data length of 0x10
                testCaseNb = (byte) 13 ;
            
                bRes = false ;
                try {
                    if (envHdlr.getShortMessageLength() == (short)0x0020)
                        bRes = true;
                }
                catch (Exception e)    {    
                    bRes = false ;
                }
                reportTestOutcome(testCaseNb, bRes) ;
                break;
            
            case (byte) 13 :
                // --------------------------------------------
                // Test Case 14 : Test with PCNTR = 7, no RC/CC/DS and data length of 0x03 
                testCaseNb = (byte) 14 ;
            
                bRes = false ;
                try {
                    if (envHdlr.getShortMessageLength() == (short)0x001A)
                        bRes = true;
                }
                catch (Exception e)    {    
                    bRes = false ;
                }
                reportTestOutcome(testCaseNb, bRes) ;
                break;
            
            case (byte) 14 :
                // --------------------------------------------
                // Test Case 15 : Test with PCNTR = 0, with RC/CC/DS length of 8 and secured data length of 0x10
                testCaseNb = (byte) 15 ;
            
                bRes = false ;
                try {
                    if (envHdlr.getShortMessageLength() == (short)0x0028)
                        bRes = true;
                }
                catch (Exception e)    {    
                    bRes = false ;
                }
                reportTestOutcome(testCaseNb, bRes) ;
                break;
            
            case (byte) 15 :
                // --------------------------------------------
                // Test Case 16 : Test with PCNTR = 0, no RC/CC/DS and SecuredDataLength = 00
                testCaseNb = (byte) 16 ;
            
                bRes = false ;
                try {
                    if (envHdlr.getShortMessageLength() == (short)0x0010)
                        bRes = true;
                }
                catch (Exception e)    {    
                    bRes = false ;
                }
                reportTestOutcome(testCaseNb, bRes) ;
                break;
            
            case (byte) 16 :
                // --------------------------------------------
                // Test Case 17 : Test with PCNTR = 0, no RC/CC/DS and UserDataLength = maximum length (0x8C) for a single SMS
                testCaseNb = (byte) 17 ;
            
                bRes = false ;
                try {
                    if (envHdlr.getShortMessageLength() == (short)0x0089)
                        bRes = true;
                }
                catch (Exception e)    {    
                    bRes = false ;
                }
                reportTestOutcome(testCaseNb, bRes) ;
                break;
            
            case (byte) 17 :
                // --------------------------------------------
                // Test Case 18 : Verify it is the first TPDU TLV: Send a SMS PP with 2 TPDU TLV with two different user data lengths:
                // 0x18 and 0x23 (with PCNTR = 0, no RC/CC/DS)
                testCaseNb = (byte) 18 ;
            
                bRes = false ;
                try {
                    if (envHdlr.getShortMessageLength() == (short)0x0015)
                        bRes = true;
                }
                catch (Exception e)    {    
                    bRes = false ;
                }
                reportTestOutcome(testCaseNb, bRes) ;
                break;
            
            case (byte) 18 :
                // --------------------------------------------
                // Test Case 19 : Send envelope SMS-PP Formatted.FindTLV() with TAG_DEVICE_IDENTITIES. 
                // GetUserDataLength() and then getValueByte() with offset 0
                testCaseNb = (byte) 19 ;
            
                bRes = false ;
                try {
                    if((envHdlr.findTLV(TAG_DEVICE_IDENTITIES,(byte)1)!=TLV_NOT_FOUND)&&
                        (envHdlr.getShortMessageLength() == (short)0x0015)&&
                        (envHdlr.getValueByte((short)0)==0x40))
                                            bRes = true;
                }
                catch (Exception e)    {    
                    bRes = false ;
                }
                reportTestOutcome(testCaseNb, bRes) ;
                break;
            
            case (byte) 19 :
                // --------------------------------------------
                // Test Case 20 : Test with UserDataLength = maximum length (0x010D) with 2 concatenated SMS 
                testCaseNb = (byte) 20 ;
            
                bRes = false ;
                try {
                    if (envHdlr.getShortMessageLength() == (short)0x010A)
                        bRes = true;
                }
                catch (Exception e)    {    
                    bRes = false ;
                }
                reportTestOutcome(testCaseNb, bRes) ;
                break;
            
            //=================================================================
            //=========          FORMATTED SMS CB triggering          =========
            //=================================================================
            case (byte)20 :
                // --------------------------------------------
                // Test Case 21 : Test with PCNTR = 0, no RC/CC/DS and data length of 0x10
                bRes = false ;
                testCaseNb = (byte) 21 ;
                try {
                    if (envHdlr.getShortMessageLength() == (short)0x0052)
                        bRes = true;
                }
                catch (Exception e)     {
                    bRes = false ;
                }
                reportTestOutcome(testCaseNb, bRes) ;
                break;
                
            case (byte)21 :
                // --------------------------------------------
                // Test Case 22 : Test with PCNTR = 7, no RC/CC/DS 
                // and data length of 0x03 (ciphering shall be used)
                testCaseNb = (byte) 22 ;
            
                bRes = false ;
                try {
                    if (envHdlr.getShortMessageLength() == (short)0x0052)
                        bRes = true;
                }
                catch (Exception e)     {
                    bRes = false ;
                }
                reportTestOutcome(testCaseNb, bRes) ;
                break;
                
            case (byte)22 :
                // --------------------------------------------
                // Test Case 23 : Test with PCNTR = 0, with RC/CC/DS length of 8 and secured data length of 0x10
                testCaseNb = (byte) 23 ;
            
                bRes = false ;
                try {
                    if (envHdlr.getShortMessageLength() == (short)0x0052)
                        bRes = true;
                }
                catch (Exception e)     {
                    bRes = false ;
                }
                reportTestOutcome(testCaseNb, bRes) ;
                break;
                
            case (byte)23 :
                // --------------------------------------------
                // Test Case 24 : getShortMessageLength with length = 0
                testCaseNb = (byte) 24 ;
            
                bRes = false ;
                try {
                    if (envHdlr.getShortMessageLength() == (short)0x0052)
                        bRes = true;
                }
                catch (Exception e)     {
                    bRes = false ;
                }
                reportTestOutcome(testCaseNb, bRes) ;
                break;
                
            case (byte)24 :
                // --------------------------------------------
                // Test Case 25 : Secured data length = 0x33 
                testCaseNb = (byte) 25 ;
            
                bRes = false ;
                try {
                    if (envHdlr.getShortMessageLength() == (short)0x0052)
                        bRes = true;
                }
                catch (Exception e)     {
                    bRes = false ;
                }
                reportTestOutcome(testCaseNb, bRes) ;
                break;
                
            case (byte)25 :
                // --------------------------------------------
                // Test Case 26 : Verify it is the first Cell Broadcast Page TLV:
                // Send a SMS CB with 2 Cell Broadcast Page TLV with two different user data lengths:
                // 0x18 and 0x23 (with PCNTR = 0, no RC/CC/DS)
                testCaseNb = (byte) 26 ;
            
                bRes = false ;
                try {
                    if ((envHdlr.getShortMessageLength() == (short)0x0052) &&
                        (envHdlr.getValueShort((short)6) == (short)0x0016))
                        bRes = true;
                }
                catch (Exception e)     {
                    bRes = false ;
                }
                reportTestOutcome(testCaseNb, bRes) ;
                break;
                
            case (byte) 26 :
                // --------------------------------------------
                // Test Case 27 : findTLV device Identities (Formatted SMS CB envelope)
                testCaseNb = (byte) 27 ;
            
                bRes = false ;
                try {
                    if((envHdlr.findTLV(TAG_DEVICE_IDENTITIES,(byte)1)!=TLV_NOT_FOUND)&&
                        (envHdlr.getShortMessageLength() == (short)0x0052)&&
                        (envHdlr.getValueByte((short)0)==0x00))
                                            bRes = true;
                }
                catch (Exception e)    {    
                    bRes = false ;
                }
                reportTestOutcome(testCaseNb, bRes) ;
                break;
            
            
            //=================================================================
            //=========                  ERROR TESTS                  =========
            //=================================================================
            //*****************************************************************
            //** UNFORMATTED SMS PP UPD Triggering                            *
            //*****************************************************************
            
            case (byte) 27:
                // --------------------------------------------
                // Test Case 28 : Test with UNFORMATTED_SMS_PP_ENV and TP-OA length of 2,
                // and user data length of 0x3D
                testCaseNb = (byte) 28 ;
            
                bRes = false ;
                try {
                    if (envHdlr.getShortMessageLength() == (short)0x003D)
                        bRes = true;
                }
                catch (Exception e)     {
                    bRes = false ;
                }
                reportTestOutcome(testCaseNb, bRes) ;
                 break;
            
            case (byte) 28 :
                // --------------------------------------------
                // Test Case 29 : try to apply the getShortMessageLength method on an Unformatted SMS PP envelope
                testCaseNb = (byte) 29 ;
            
                bRes = false ;
                try {
                    if (envHdlr.getShortMessageLength() == (short)0x003D)
                        bRes = true;
                }
                catch (Exception e)     {
                    bRes = false ;
                }
                reportTestOutcome(testCaseNb, bRes) ;
                 break;
                 
            case (byte) 29 :
                // --------------------------------------------
                // Test Case 30 : try to apply the getShortMessageLength method on an Unformatted SMS PP envelope
                testCaseNb = (byte) 30 ;
            
                bRes = false ;
                try {
                    if (envHdlr.getShortMessageLength() == (short)0x0000)
                        bRes = true;
                }
                catch (Exception e)     {
                    bRes = false ;
                }
                reportTestOutcome(testCaseNb, bRes) ;
                 break;
                 
            case (byte) 30 :
                // --------------------------------------------
                // Test Case 31 : Test with UserDataLength = 0x7F
                testCaseNb = (byte) 31 ;
            
                bRes = false ;
                try {
                    if (envHdlr.getShortMessageLength() == (short)0x007F)
                        bRes = true;
                }
                catch (Exception e)     {
                    bRes = false ;
                }
                reportTestOutcome(testCaseNb, bRes) ;
                 break;
            
            case (byte) 31 :
                // --------------------------------------------
                // Test Case 32 : Test with UserDataLength = 0x80
                testCaseNb = (byte) 32 ;
            
                bRes = false ;
                try {
                    if (envHdlr.getShortMessageLength() == (short)0x0080)
                        bRes = true;
                }
                catch (Exception e)     {
                    bRes = false ;
                }
                reportTestOutcome(testCaseNb, bRes) ;
                 break;
                 
            case (byte) 32 :
                // --------------------------------------------
                // Test Case 33 : Test with UserDataLength = maximum length: 0x8C for a single SMS
                testCaseNb = (byte) 33 ;
            
                bRes = false ;
                try {
                    if (envHdlr.getShortMessageLength() == (short)0x008C)
                        bRes = true;
                }
                catch (Exception e)     {
                    bRes = false ;
                }
                reportTestOutcome(testCaseNb, bRes) ;
                 break;
                 
            case (byte) 33 :
                // --------------------------------------------
                // Test Case 34 : Verify it is the first TPDU TLV: Send a SMS PP with 2 TPDU TLV with 
                // two different user data lengths: 0x18 and 0x23
                testCaseNb = (byte) 34 ;
            
                bRes = false ;
                try {
                    if (envHdlr.getShortMessageLength() == (short)0x0018)
                        bRes = true;
                }
                catch (Exception e)     {
                    bRes = false ;
                }
                reportTestOutcome(testCaseNb, bRes) ;
                 break;
            
            case (byte) 34 :
                // --------------------------------------------
                // Test Case 35 : Send envelope SMS-PP Unformatted.FindTLV() with TAG_DEVICE_IDENTITIES.
                // GetUserDataLength() and then getValueByte() with offset 0 (first user data = 0x55)
                testCaseNb = (byte) 35 ;
            
                bRes = false ;
                try {
                    if((envHdlr.findTLV(TAG_DEVICE_IDENTITIES,(byte)1)!=TLV_NOT_FOUND)&&
                        (envHdlr.getShortMessageLength() == (short)0x0018)&&
                        (envHdlr.getValueByte((short)0)==0x00))
                                            bRes = true;
                }
                catch (Exception e)    {    
                    bRes = false ;
                }
                reportTestOutcome(testCaseNb, bRes) ;
                break;
                
                //*****************************************************************
                //** UNFORMATTED SMS PP UPD Triggering                         *
                //*****************************************************************
            case (byte) 35 :
                // --------------------------------------------
                // Test Case 34 : Test with UNFORMATTED_SMS_PP_UPD and TP-OA length of 2, 
                // and user data length of 0x3D
                testCaseNb = (byte) 36 ;
            
                bRes = false ;
                try {
                    if (envHdlr.getShortMessageLength() == (short)0x003D)
                        bRes = true;
                }
                catch (Exception e)     {
                    bRes = false ;
                }
                reportTestOutcome(testCaseNb, bRes) ;
                break;
            
            case (byte) 36 :
                // --------------------------------------------
                // Test Case 37 : Test with TP-OA length of 12, and user data length of 0x3D
                testCaseNb = (byte) 37 ;
            
                bRes = false ;
                try {
                    if (envHdlr.getShortMessageLength() == (short)0x003D)
                        bRes = true;
                }
                catch (Exception e)     {
                    bRes = false ;
                }
                reportTestOutcome(testCaseNb, bRes) ;
                break;
            
            case (byte) 37 :
                // --------------------------------------------
                // Test Case 38 : Test with UserDataLength = 0x00
                testCaseNb = (byte) 38 ;
            
                bRes = false ;
                try {
                    if (envHdlr.getShortMessageLength() == (short)0x0000)
                        bRes = true;
                }
                catch (Exception e)     {
                    bRes = false ;
                }
                reportTestOutcome(testCaseNb, bRes) ;
                break;
            
            case (byte) 38 :
                // --------------------------------------------
                // Test Case 39 : Test with UserDataLength = 0x7F
                testCaseNb = (byte) 39 ;
            
                bRes = false ;
                try {
                    if (envHdlr.getShortMessageLength() == (short)0x007F)
                        bRes = true;
                }
                catch (Exception e)     {
                    bRes = false ;
                }
                reportTestOutcome(testCaseNb, bRes) ;
                break;
            
            case (byte) 39 :
                // --------------------------------------------
                // Test Case 40 : Test with UserDataLength = 0x80
                testCaseNb = (byte) 40 ;
            
                bRes = false ;
                try {
                    if (envHdlr.getShortMessageLength() == (short)0x0080)
                        bRes = true;
                }
                catch (Exception e)     {
                    bRes = false ;
                }
                reportTestOutcome(testCaseNb, bRes) ;
                break;
                 
            case (byte) 40 :
                // --------------------------------------------
                // Test Case 41 : Verify it is the first TPDU TLV: 
                // Send a SMS PP with 2 TPDU TLV with two different user data lengths: 0x18 and 0x23
                testCaseNb = (byte) 41 ;
            
                bRes = false ;
                try {
                    if (envHdlr.getShortMessageLength() == (short)0x0018)
                        bRes = true;
                }
                catch (Exception e)     {
                    bRes = false ;
                }
                reportTestOutcome(testCaseNb, bRes) ;
                break;
                 
            case (byte) 41 :
                // --------------------------------------------
                // Test Case 42 : Test with UserDataLength = maximum length: 0x8C for a single SMS
                testCaseNb = (byte) 42 ;
            
                bRes = false ;
                try {
                    if (envHdlr.getShortMessageLength() == (short)0x008C)
                        bRes = true;
                }
                catch (Exception e)     {
                    bRes = false ;
                }
                reportTestOutcome(testCaseNb, bRes) ;
                break;
                 
            case (byte) 42 :
                // --------------------------------------------
                // Test Case 43 : Send envelope SMS-PP Formatted.
                // FindTLV() with TAG_DEVICE_IDENTITIES. GetUserDataLength() and then getValueByte() with offset 0
                testCaseNb = (byte) 43 ;
            
                bRes = false ;
                try {
                    if((envHdlr.findTLV(TAG_DEVICE_IDENTITIES,(byte)1)!=TLV_NOT_FOUND)&&
                        (envHdlr.getShortMessageLength() == (short)0x0018)&&
                        (envHdlr.getValueByte((short)0)==0x00))
                                            bRes = true;
                }
                catch (Exception e)    {    
                    bRes = false ;
                }
                reportTestOutcome(testCaseNb, bRes) ;
                break;
                
                //*****************************************************************
                //** UNFORMATTED SMS CB Triggering                                *
                //*****************************************************************
            case (byte) 43 :
                // --------------------------------------------
                // Test Case 44: Test with UNFORMATTED_SMS_CB
                testCaseNb = (byte) 44 ;
            
                bRes = false ;
                try {
                    if (envHdlr.getShortMessageLength() == (short)0x0052)   
                        bRes = true;
                }
                catch (Exception e)     {
                    bRes = false ;
                }
                reportTestOutcome(testCaseNb, bRes) ;
                break;
            
                 
            case (byte) 44 :
                // --------------------------------------------
                // Test Case 44: Test with UNFORMATTED_SMS_CB
                testCaseNb = (byte) 45 ;
            
                bRes = false ;
                try {
                    if (envHdlr.getShortMessageLength() == (short)0x0052)   
                        bRes = true;
                }
                catch (Exception e)     {
                    bRes = false ;
                }
                reportTestOutcome(testCaseNb, bRes) ;
                break;
                 
            case (byte) 45 :
                // --------------------------------------------
                // Test Case 46 : Send envelope SMS-PP Formatted.
                // FindTLV() with TAG_DEVICE_IDENTITIES. GetUserDataLength() and then getValueByte() with offset 0
                testCaseNb = (byte) 46 ;
            
                bRes = false ;
                try {
                    if((envHdlr.findTLV(TAG_DEVICE_IDENTITIES,(byte)1)!=TLV_NOT_FOUND)&&
                        (envHdlr.getShortMessageLength() == (short)0x0052)&&  
                        (envHdlr.getValueByte((short)0)==0x00))
                                            bRes = true;
                }
                catch (Exception e)    {    
                    bRes = false ;
                }
                reportTestOutcome(testCaseNb, bRes) ;
                break;
            
                //*****************************************************************
                //** Unrecognized Envelope Triggering                             *
                //*****************************************************************
            case (byte) 46 :
                // --------------------------------------------
                // Test Case 47: Send an Unrecognized Envelope with neither TPDU TLV 
                // nor Cell Broadcast Page TLV, then call the method.
                testCaseNb = (byte) 47 ;
            
                bRes = false ;
                try {
                    short returnvalue = envHdlr.getShortMessageLength();
                }
                catch (ToolkitException e)    {
                    if(e.getReason()== ToolkitException.UNAVAILABLE_ELEMENT ) 
                        bRes = true ;
                    else
                        bRes = false ;
                }
                catch (Exception e)    {    
                        bRes = false ;
                }
                reportTestOutcome(testCaseNb, bRes) ;
                break;
            }
    }
}
