//-----------------------------------------------------------------------------
//    Package Definition
//-----------------------------------------------------------------------------
package uicc.usim.test.usatframework.ufw_apt_eusu;

import org._3gpp.ct.wg6.usim.jcapi.userclass.*;
import org.etsi.scp.wg3.uicc.jcapi.userclass.*;

//-----------------------------------------------------------------------------
//  Imports
//-----------------------------------------------------------------------------
import org.etsi.scp.wg3.uicc.jcapi.userinterface.*;


public class Test_Ufw_Apt_Eusu extends UiccTestModel {
    static final String CAP_FILE_PATH = "uicc/usim/test/usatframework/ufw_apt_eusu";
    static final String CLASS_AID_1   = "A0000000 871005FF FFFFFF89 50010001";
    static final String APPLET_AID_1  = "A0000000 871005FF FFFFFF89 50010102";
    
    static final String MF = "3F00";
    static final String DF_TELECOM = "7F10";
    static final String EF_SMS = "6F3C";
    
    static final String SMS_U_SINGLE = "03028100 00088155 6677887F F6001129" +
                                       "12000004 10AAAAAA AAAAAAAA AAAAAAAA" +
                                       "AAAAAAAA AAFFFFFF FFFFFFFF FFFFFFFF" +
                                       "FFFFFFFF FFFFFFFF FFFFFFFF FFFFFFFF" +
                                       "FFFFFFFF FFFFFFFF FFFFFFFF FFFFFFFF" +
                                       "FFFFFFFF FFFFFFFF FFFFFFFF FFFFFFFF" +
                                       "FFFFFFFF FFFFFFFF FFFFFFFF FFFFFFFF" +
                                       "FFFFFFFF FFFFFFFF FFFFFFFF FFFFFFFF" +
                                       "FFFFFFFF FFFFFFFF FFFFFFFF FFFFFFFF" +
                                       "FFFFFFFF FFFFFFFF FFFFFFFF FFFFFFFF" +
                                       "FFFFFFFF FFFFFFFF FFFFFFFF FFFFFFFF";
    
    static final String SMS_U_CONCAT1 = "03028100 40088155 6677887F F6011129" +
                                        "12000004 46050003 A1020102 7000BBBB" +
                                        "BBBBBBBB BBBBBBBB BBBBBBBB BBBBBBBB" +
                                        "BBBBBBBB BBBBBBBB BBBBBBBB BBBBBBBB" +
                                        "BBBBBBBB BBBBBBBB BBBBBBBB BBBBBBBB" +
                                        "BBBBBBBB BBBBBBBB BBBBBBFF FFFFFFFF" +
                                        "FFFFFFFF FFFFFFFF FFFFFFFF FFFFFFFF" +
                                        "FFFFFFFF FFFFFFFF FFFFFFFF FFFFFFFF" +
                                        "FFFFFFFF FFFFFFFF FFFFFFFF FFFFFFFF" +
                                        "FFFFFFFF FFFFFFFF FFFFFFFF FFFFFFFF" +
                                        "FFFFFFFF FFFFFFFF FFFFFFFF FFFFFFFF";
    
    static final String SMS_U_CONCAT2 = "03028100 40088155 6677887F F6021129" +
                                        "12000004 36050003 A10202CC CCCCCCCC" +
                                        "CCCCCCCC CCCCCCCC CCCCCCCC CCCCCCCC" +
                                        "CCCCCCCC CCCCCCCC CCCCCCCC CCCCCCCC" +
                                        "CCCCCCCC CCCCCCCC CCCCCCFF FFFFFFFF" +
                                        "FFFFFFFF FFFFFFFF FFFFFFFF FFFFFFFF" +
                                        "FFFFFFFF FFFFFFFF FFFFFFFF FFFFFFFF" +
                                        "FFFFFFFF FFFFFFFF FFFFFFFF FFFFFFFF" +
                                        "FFFFFFFF FFFFFFFF FFFFFFFF FFFFFFFF" +
                                        "FFFFFFFF FFFFFFFF FFFFFFFF FFFFFFFF" +
                                        "FFFFFFFF FFFFFFFF FFFFFFFF FFFFFFFF";
    
    private USimAPITestCardService test;
    APDUResponse response;

    public Test_Ufw_Apt_Eusu() {
        test = USimAPITestCardService.getTheUSimTestCardService();
    }

    public boolean run() {
        boolean result = true;

        // test script
        test.reset();
        test.terminalProfileSession("1719");

        // Install package
        test.loadPackage(CAP_FILE_PATH);

        // Install Applet1
        test.installApplet(CAP_FILE_PATH, CLASS_AID_1, APPLET_AID_1,
            "8008" + // TLV UICC Toolkit application specific parameters
            "01" + // V Priority Level
            "00" + // V Max. number of timers
            "00" + // V Maximum text length for a menu entry
            "00" + // V Maximum number of menu entries                              
            "00" + // V Maximum number of channels 
            "00" + // LV Minimum Security Level field
            "00" + // LV TAR Value(s) 
            "00"); // V Maximum number of services

        test.reset();
        test.terminalProfileSession("1719");
        
        test.selectFile(MF);
        test.selectFile(DF_TELECOM);
        test.selectFile(EF_SMS);

        
        /**
         * Testcase 1
         */
        result &= test.updateRecord("01", "04", SMS_U_SINGLE).checkSw("9000");

        result &= test.updateRecord("01", "04", SMS_U_CONCAT1).checkSw("9000");
        result &= test.updateRecord("02", "04", SMS_U_CONCAT2).checkSw("9000");
       

        /**
         * Testcase 2
         */
        result &= test.updateRecord("01", "04", SMS_U_SINGLE).checkSw("9000");

        result &= test.updateRecord("01", "04", SMS_U_CONCAT1).checkSw("9000");
        result &= test.updateRecord("02", "04", SMS_U_CONCAT2).checkSw("9000");
        
        test.unrecognizedEnvelope();

        result &= test.updateRecord("01", "04", SMS_U_SINGLE).checkSw("9000");

        result &= test.updateRecord("01", "04", SMS_U_CONCAT1).checkSw("9000");
        result &= test.updateRecord("02", "04", SMS_U_CONCAT2).checkSw("9000");
        
        
        
        /***********************************/
        /**         Check results          */
        /***********************************/
        // Select applet1
        response = test.selectApplication(APPLET_AID_1);
        result &= response.checkData("10" + APPLET_AID_1 + "08CCCCCC CCCCCCCC CC");

        test.reset();
        test.terminalProfileSession("1719");

        // Delete Applet1 
        test.deleteApplet(APPLET_AID_1);

        // Delete Package
        test.deletePackage(CAP_FILE_PATH);

        return result;
    }
}
