//-----------------------------------------------------------------------------
//ufw_fws_inda_4.java
//-----------------------------------------------------------------------------

//-----------------------------------------------------------------------------
//Package Definition
//-----------------------------------------------------------------------------
package uicc.usim.test.usatframework.ufw_fws_inda;

import uicc.usim.test.util.*;
import uicc.usim.toolkit.*;

//-----------------------------------------------------------------------------
//Imports
//-----------------------------------------------------------------------------

/**
 * Test Area : uicc.usim.test.ufwk.ufw_fws_inda
 *
 * @version 0.0.1 - 6 sept. 2005
 * @author 3GPP T3 SWG API
 */
public class Ufw_Fws_Inda_4 extends TestToolkitApplet implements uicc.usim.toolkit.ToolkitConstants
{
    // Number of tests
    byte testCaseNb = (byte) 0x00;
    byte[] buffer = new byte[25];
    
    /**
    * Constructor of the applet
    */
    public Ufw_Fws_Inda_4 () 
    {
    }
    
    
    /**
    * Method called by the JCRE at the installation of the applet
    */
    public static void install(byte bArray[], short bOffset, byte bLength) 
    {
        // Create a new applet instance
        Ufw_Fws_Inda_4  thisApplet = new Ufw_Fws_Inda_4();
        
        // Register the new applet instance to the JCRE            
        thisApplet.register(bArray, (short)(bOffset+1), bArray[bOffset]);
        
        // Initialise the data of the test applet
        thisApplet.init(); 
        
        //register to EVENT_FORMATTED_SMS_PP_ENV
        thisApplet.obReg.setEvent(EVENT_FORMATTED_SMS_PP_ENV);
        
        // Register to EVENT_FORMATTED_SMS_CB
        thisApplet.obReg.setEvent(EVENT_FORMATTED_SMS_CB);

    }
    
    
    /**
     * Method called by the SIM Toolkit Framework
    */
    public void processToolkit(short event) 
    {
        // Result of each test
        boolean bRes = false;

        // Get the system instance of the EnvelopeHandler class
        USATEnvelopeHandler envHdlr = USATEnvelopeHandlerSystem.getTheHandler();

        // Sets the test case number
        testCaseNb = 1;
        
        // --------------------------------------------
        // Test Case 5.2: data ciphered; integrity checked via cryptographic checksum
        //
        // In this test case it is checked that the checksum is verified and the data are deciphered
        // before being passed to the applet

        short length = 0;
        short offset = 0;
        byte data = 0;

        try {
            bRes = false;
            offset = envHdlr.getSecuredDataOffset();
            length = envHdlr.getSecuredDataLength();
            envHdlr.copyValue(offset, (byte[])buffer, (short)0x00, length);
            data = buffer [0];
            if ((data == (byte)3) & (length == (byte)1)) {
                bRes = true;
            }
        }
        catch (Exception e)    {
            bRes = false;
        }
        reportTestOutcome(testCaseNb, bRes);
    }
}
