//-----------------------------------------------------------------------------
//Package Definition
//-----------------------------------------------------------------------------

package uicc.usim.test.usatframework.ufw_hin_uehd;
//-----------------------------------------------------------------------------
//Imports
//-----------------------------------------------------------------------------



import javacard.framework.*;
import uicc.toolkit.EnvelopeHandler;
import uicc.toolkit.EnvelopeHandlerSystem;
import uicc.toolkit.ProactiveHandler;
import uicc.toolkit.ProactiveHandlerSystem;
import uicc.usim.test.util.TestToolkitApplet;
import uicc.usim.toolkit.USATEnvelopeHandler;
import uicc.usim.toolkit.USATEnvelopeHandlerSystem;


public class Ufw_Hin_Uehd_1 extends TestToolkitApplet {


    /** number of the actual test case */
    private byte    testCaseNb = (byte) 0x01;

    /** flag for test case 1. will be set to true if triggered */
    private boolean bRes       = false;

    private static byte TAG_SMS_TPDU = (byte)0x0B;

    private static byte TAG_CELL_BROADCAST_PAGE = (byte)0x0C;

    private static byte BTAG_SMS_PP_DOWNLOAD = (byte)0xD1;

    private byte result = (byte)0xFF;

    private byte comparebuffer1[] = new byte[100];

    private byte comparebuffer2[] = new byte[20];

    /** contains sms tpdu of  formatted sms pp upd*/
    private final byte formatted_smstpdu[] = new byte[]{(byte)0x40, (byte)0x02, (byte)0x81, (byte)0x55,
                                                         (byte)0x7F, (byte)0xF6, (byte)0x00, (byte)0x11,
                                                         (byte)0x29, (byte)0x12, (byte)0x00, (byte)0x00,
                                                         (byte)0x04, (byte)0x3D, (byte)0x02, (byte)0x70,
                                                         (byte)0x00, (byte)0x00, (byte)0x38, (byte)0x0D,
                                                         (byte)0x08, (byte)0x00, (byte)0x00, (byte)0x00,
                                                         (byte)0x50, (byte)0x01, (byte)0x01, (byte)0x00,
                                                         (byte)0x00, (byte)0x00, (byte)0x00, (byte)0x01,
                                                         (byte)0x00, (byte)0x11, (byte)0x22, (byte)0x33,
                                                         (byte)0x44, (byte)0x55, (byte)0x66, (byte)0x77,
                                                         (byte)0x88, (byte)0x99, (byte)0x10, (byte)0x11,
                                                         (byte)0x12, (byte)0x13, (byte)0x14, (byte)0x15,
                                                         (byte)0x16, (byte)0x17, (byte)0x18, (byte)0x19,
                                                         (byte)0x1A, (byte)0x1B, (byte)0x1C, (byte)0x1D,
                                                         (byte)0x1E, (byte)0x1F, (byte)0x20, (byte)0x24,
                                                         (byte)0x22, (byte)0x23, (byte)0x24, (byte)0x25,
                                                         (byte)0x26, (byte)0x27, (byte)0x28, (byte)0x29,
                                                         (byte)0x2A, (byte)0x2B, (byte)0x2C, (byte)0x2D,
                                                         (byte)0x2E, (byte)0x2F, (byte)0x30};


    /** contains sms tpdu of  unformatted sms pp upd*/
    private final byte unformatted_smstpdu[] = new byte[]{ (byte)0x00, (byte)0x02, (byte)0x81, (byte)0x55,
                                                           (byte)0x7F, (byte)0xF6, (byte)0x00, (byte)0x11,
                                                           (byte)0x29, (byte)0x12, (byte)0x00, (byte)0x00,
                                                           (byte)0x04, (byte)0x3D, (byte)0x01, (byte)0x02,
                                                           (byte)0x03, (byte)0x04, (byte)0x05, (byte)0x06,
                                                           (byte)0x07, (byte)0x08, (byte)0x09, (byte)0x0A,
                                                           (byte)0x0B, (byte)0x0C, (byte)0x0D, (byte)0x0E,
                                                           (byte)0x0F, (byte)0x10, (byte)0x11, (byte)0x12,
                                                           (byte)0x13, (byte)0x14, (byte)0x15, (byte)0x16,
                                                           (byte)0x17, (byte)0x18, (byte)0x19, (byte)0x1A,
                                                           (byte)0x1B, (byte)0x1C, (byte)0x1D, (byte)0x1E,
                                                           (byte)0x1F, (byte)0x20, (byte)0x21, (byte)0x22,
                                                           (byte)0x23, (byte)0x24, (byte)0x25, (byte)0x26,
                                                           (byte)0x27, (byte)0x28, (byte)0x29, (byte)0x2A,
                                                           (byte)0x2B, (byte)0x2C, (byte)0x2D, (byte)0x2E,
                                                           (byte)0x2F, (byte)0x30, (byte)0x31, (byte)0x32,
                                                           (byte)0x33, (byte)0x34, (byte)0x35, (byte)0x36,
                                                           (byte)0x37, (byte)0x38, (byte)0x39, (byte)0x3A,
                                                           (byte)0x3B, (byte)0x3C, (byte)0x3D };

    /** contains the value of envelope call control by naa*/
    private final  byte naa_value[] = new byte[]{(byte)0x82,(byte)0x02,(byte)0x82, (byte)0x81,
                                                 (byte)0x86,(byte)0x02,(byte)0x81, (byte)0x01,
                                                 (byte)0x93,(byte)0x07,(byte)0x81, (byte)0xF2,
                                                 (byte)0xA3,(byte)0x34,(byte)0x05, (byte)0x76,
                                                 (byte)0x67};

    private byte disptextbuffer[] = new byte[]{(byte)0xA1,(byte)0xB2,(byte)0xC3,(byte)0xD4,(byte)0xE5};


      /**
     * Method called by the JCRE at the installation of the applet.
     */
    public static void install(byte[] bArray, short bOffset, byte bLength) throws ISOException
    {
        // Create a new applet instance.
        Ufw_Hin_Uehd_1 applet = new Ufw_Hin_Uehd_1();

        // Register the new applet instance to the JCRE
        applet.register(bArray, (short) (bOffset + 1), bArray[bOffset]);

        // Initialise the data of the test applet.
        applet.init();

        short[] eventList = new short[] {
                                        EVENT_FORMATTED_SMS_CB,
                                        EVENT_FORMATTED_SMS_PP_ENV,
                                        EVENT_FORMATTED_SMS_PP_UPD,
                                        EVENT_UNFORMATTED_SMS_CB,
                                        EVENT_UNFORMATTED_SMS_PP_ENV,
                                        EVENT_UNFORMATTED_SMS_PP_UPD,
                                        EVENT_MO_SHORT_MESSAGE_CONTROL_BY_SIM,
                                        EVENT_CALL_CONTROL_BY_NAA,
                                        };
        //register to all events defined in 3gpp 31.130
        applet.obReg.setEventList(eventList,(short)0,(short)eventList.length);
    }//end install method


    /**
     * Test: ProactiveResponseHandler TLV list shall be empty before the first
     * call to the ProactiveHandler.send() method
     */
    public void processToolkit(short event) throws ISOException
    {
        bRes = false;
        USATEnvelopeHandler uenvHdlr = USATEnvelopeHandlerSystem.getTheHandler();
        try{

            switch (event){
                //--------------------------------------------------------
                //TC 1
                //--------------------------------------------------------
                case EVENT_FORMATTED_SMS_PP_ENV:
                    testCaseNb=(byte)0x01;
                    result=(byte)0x00; //
                    //copy content of envelope handler to buffer
                    comparebuffer1 = new byte[uenvHdlr.getLength()];
                    uenvHdlr.copy(comparebuffer1,(short)0,uenvHdlr.getLength());
                    if( uenvHdlr.findTLV(TAG_SMS_TPDU,(byte)0x01)!=TLV_NOT_FOUND){
                        sendDisplayText();
                       //before terminal response to display text a envelope call controll by naa is send
                       //check that SMS TPDU is still the selected TLV structure
                        byte smstpdu[] = new byte[]{(byte)0x40, (byte)0x0B, (byte)0xD0, (byte)0x21,
                                (byte)0x43, (byte)0x65, (byte)0x87, (byte)0x09,
                                (byte)0xF1, (byte)0x7F, (byte)0xF6, (byte)0xFF,
                                (byte)0xFF, (byte)0xFF, (byte)0xFF, (byte)0xFF,
                                (byte)0xFF, (byte)0xFF, (byte)0x1E, (byte)0x02,
                                (byte)0x70, (byte)0x00, (byte)0x00, (byte)0x19,
                                (byte)0x0D, (byte)0x00, (byte)0x00, (byte)0x00,
                                (byte)0x00, (byte)0x50, (byte)0x01, (byte)0x01,
                                (byte)0x00, (byte)0x00, (byte)0x00, (byte)0x00,
                                (byte)0x00, (byte)0x00, (byte)0xA1, (byte)0xB2,
                                (byte)0xC3, (byte)0xD3, (byte)0xE4, (byte)0xF5,
                                (byte)0xAA, (byte)0xBB, (byte)0xCC, (byte)0xDD,
                                (byte)0xEE};
                       result|=uenvHdlr.compareValue((short)0,smstpdu,(short)0,(short)smstpdu.length);

                       //content of EnvelopeHanlder shall be the same just like the beginning
                       comparebuffer2=new byte[(short)uenvHdlr.getLength()];
                       uenvHdlr.copy(comparebuffer2,(short)0,(short)uenvHdlr.getLength());
                       result |= Util.arrayCompare(comparebuffer1,(short)0,comparebuffer2,(short)0,(short)comparebuffer2.length);
                       if (result==(byte)0x00){bRes=true;}
                    }
                    reportTestOutcome(testCaseNb,bRes);
                break;
                //--------------------------------------------------------
                //TC 2,8,9,10
                //--------------------------------------------------------
                case EVENT_FORMATTED_SMS_PP_UPD:
                    result=(byte)0x00; //
                    //*******************************************
                    //TC 2
                    //*******************************************
                    if (testCaseNb<7) {
                        testCaseNb=(byte)0x02;
                        //copy content of envelope handler to buffer
                        comparebuffer1 = new byte[uenvHdlr.getLength()];
                        uenvHdlr.copy(comparebuffer1,(short)0,uenvHdlr.getLength());
                        if( uenvHdlr.findTLV(TAG_SMS_TPDU,(byte)0x01)!=TLV_NOT_FOUND){
                            sendDisplayText();
                            //check content of sms tpdu
                            result|=uenvHdlr.compareValue((short)0,formatted_smstpdu,(short)0,(short)formatted_smstpdu.length);

                            //content of EnvelopeHanlder shall be the same just like the beginning
                            comparebuffer2=new byte[(short)uenvHdlr.getLength()];
                            uenvHdlr.copy(comparebuffer2,(short)0,(short)uenvHdlr.getLength());
                            result |= Util.arrayCompare(comparebuffer1,(short)0,comparebuffer2,(short)0,(short)comparebuffer2.length);
                            if (result==(byte)0x00){bRes=true;}
                        }
                    }//end test case 2
                    else {
                        //*******************************************
                        //TC 8
                        //*******************************************
                        testCaseNb=(byte)0x08;
                        //find and check device id
                        if (uenvHdlr.findTLV(TAG_DEVICE_IDENTITIES,(byte)0x01)!=TLV_NOT_FOUND) {
                            //check number of absolute record
                            if (uenvHdlr.getValueByte((short)0)!=(byte)0x01) {result=(byte)0xFF; }
                            //check efsms record status byte
                            if (uenvHdlr.getValueByte((short)1)!=(byte)0x03) {result=(byte)0xFF; }
                            //find and check address tlv
                            if (uenvHdlr.findTLV(TAG_ADDRESS,(byte)0x01)!=TLV_NOT_FOUND) {
                                byte address[] = new byte[] {(byte)0x80,(byte)0x11,(byte)0x22,(byte)0x33,(byte)0x44};
                                result |= uenvHdlr.compareValue((short)0,address,(short)0,(short)address.length);
                            }
                            //find and check sms tpdu
                            if( uenvHdlr.findTLV(TAG_SMS_TPDU,(byte)0x01)!=TLV_NOT_FOUND){
                                //check content of sms tpdu
                                result|=uenvHdlr.compareValue((short)0,formatted_smstpdu,(short)0,(short)formatted_smstpdu.length);
                            }
                            if (result==(byte)0x00) { bRes=true;}
                            reportTestOutcome(testCaseNb,bRes); //report test case 8
                        }
                        //*******************************************
                        //TC 9
                        //*******************************************
                        testCaseNb=0x09;
                        result=(byte)0x00;
                        bRes=false;
                        if(uenvHdlr.getLength()==(byte)0x58) {bRes=true;}
                        reportTestOutcome(testCaseNb,bRes); //report test case 9
                        //*******************************************
                        //TC 10
                        //*******************************************
                        testCaseNb=0x0A;
                        result=(byte)0x00;
                        bRes=false;
                        if (uenvHdlr.getTag()==BTAG_SMS_PP_DOWNLOAD) {bRes=true;}
                    }//end test case 8,9,10
                    reportTestOutcome(testCaseNb,bRes);
                 break;
                 //--------------------------------------------------------
                 //TC 3
                 //--------------------------------------------------------
                case EVENT_UNFORMATTED_SMS_PP_ENV:
                    testCaseNb=(byte)0x03;
                    result=(byte)0x00; //
                    //copy content of envelope handler to buffer
                    comparebuffer1 = new byte[uenvHdlr.getLength()];
                    uenvHdlr.copy(comparebuffer1,(short)0,uenvHdlr.getLength());
                    if( uenvHdlr.findTLV(TAG_DEVICE_IDENTITIES,(byte)0x01)!=TLV_NOT_FOUND){
                        sendDisplayText();
                        byte deviceid[]= new byte[]{(byte)0x83,(byte)0x81 };
                        result|=uenvHdlr.compareValue((short)0,deviceid,(short)0,(short)deviceid.length);

                        //content of EnvelopeHanlder shall be the same just like the beginning
                        comparebuffer2=new byte[(short)uenvHdlr.getLength()];
                        uenvHdlr.copy(comparebuffer2,(short)0,(short)uenvHdlr.getLength());
                        result |= Util.arrayCompare(comparebuffer1,(short)0,comparebuffer2,(short)0,(short)comparebuffer2.length);
                        if (result==(byte)0x00){bRes=true;}
                    }
                    reportTestOutcome(testCaseNb,bRes);
                break;
                //--------------------------------------------------------
                //TC 4,11,12,13
                //--------------------------------------------------------
                case EVENT_UNFORMATTED_SMS_PP_UPD:
                    //*******************************************
                    //TC 4
                    //*******************************************
                    if (testCaseNb<10) {
                        testCaseNb=(byte)0x04;
                        result=(byte)0x00; //
                        //copy content of envelope handler to buffer
                        comparebuffer1 = new byte[uenvHdlr.getLength()];
                        uenvHdlr.copy(comparebuffer1,(short)0,uenvHdlr.getLength());
                        if( uenvHdlr.findTLV(TAG_SMS_TPDU,(byte)0x01)!=TLV_NOT_FOUND){
                            sendDisplayText();
                            //check content of sms tpdu
                            result|=uenvHdlr.compareValue((short)0,unformatted_smstpdu,(short)0,(short)unformatted_smstpdu.length);

                            //content of EnvelopeHanlder shall be the same just like the beginning
                            comparebuffer2=new byte[(short)uenvHdlr.getLength()];
                            uenvHdlr.copy(comparebuffer2,(short)0,(short)uenvHdlr.getLength());
                            result |= Util.arrayCompare(comparebuffer1,(short)0,comparebuffer2,(short)0,(short)comparebuffer2.length);
                            if (result==(byte)0x00){bRes=true;}
                        }
                    }//end test case 4
                    else {
                        //*******************************************
                        //TC 11
                        //*******************************************
                        testCaseNb=(byte)0x0B;
                        //find and check device id
                        if (uenvHdlr.findTLV(TAG_DEVICE_IDENTITIES,(byte)0x01)!=TLV_NOT_FOUND) {
                            //check number of absolute record
                            if (uenvHdlr.getValueByte((short)0)!=(byte)0x01) {result=(byte)0xFF; }
                            //check efsms record status byte
                            if (uenvHdlr.getValueByte((short)1)!=(byte)0x03) {result=(byte)0xFF; }
                            //find and check address tlv
                            if (uenvHdlr.findTLV(TAG_ADDRESS,(byte)0x01)!=TLV_NOT_FOUND) {
                                byte address[] = new byte[] {(byte)0x80,(byte)0x11,(byte)0x22,(byte)0x33,(byte)0x44};
                                result |= uenvHdlr.compareValue((short)0,address,(short)0,(short)address.length);
                            }
                            //find and check sms tpdu
                            if( uenvHdlr.findTLV(TAG_SMS_TPDU,(byte)0x01)!=TLV_NOT_FOUND){
                                //check content of sms tpdu
                                result|=uenvHdlr.compareValue((short)0,unformatted_smstpdu,(short)0,(short)unformatted_smstpdu.length);
                            }
                            if (result==(byte)0x00) { bRes=true;}
                            reportTestOutcome(testCaseNb,bRes); //report test case 8
                        }
                        //*******************************************
                        //TC 12
                        //*******************************************
                        testCaseNb=0x0C;
                        result=(byte)0x00;
                        bRes=false;
                        if(uenvHdlr.getLength()==(byte)0x58) {bRes=true;}
                        reportTestOutcome(testCaseNb,bRes); //report test case 9
                        //*******************************************
                        //TC 13
                        //*******************************************
                        testCaseNb=0x0D;
                        result=(byte)0x00;
                        bRes=false;
                        if (uenvHdlr.getTag()==BTAG_SMS_PP_DOWNLOAD) {bRes=true;}
                    }//end test case 11,12,13
                    reportTestOutcome(testCaseNb,bRes);//test case 4 or 13
                break;
                //--------------------------------------------------------
                //TC 5
                //--------------------------------------------------------
                case EVENT_UNFORMATTED_SMS_CB:
                    testCaseNb=(byte)0x05;
                    result=(byte)0x00; //
                    //copy content of envelope handler to buffer
                    comparebuffer1 = new byte[uenvHdlr.getLength()];
                    uenvHdlr.copy(comparebuffer1,(short)0,uenvHdlr.getLength());
                    if( uenvHdlr.findTLV(TAG_CELL_BROADCAST_PAGE,(byte)0x01)!=TLV_NOT_FOUND){
                        sendDisplayText();
                        byte cbpage[]= new byte[]{  (byte)0xA7, (byte)0x51, (byte)0x10, (byte)0xA0,
                                                    (byte)0xF6, (byte)0x11, (byte)0x00, (byte)0x30,
                                                    (byte)0x0D, (byte)0x00, (byte)0x00, (byte)0x00,
                                                    (byte)0x00, (byte)0x50, (byte)0x01, (byte)0x01,
                                                    (byte)0x00, (byte)0x00, (byte)0x00, (byte)0x00,
                                                    (byte)0x00, (byte)0x00, (byte)0x01, (byte)0x02,
                                                    (byte)0x03, (byte)0x04, (byte)0x05, (byte)0x06,
                                                    (byte)0x07, (byte)0x08, (byte)0x09, (byte)0x0A,
                                                    (byte)0x0B, (byte)0x0C, (byte)0x0D, (byte)0x0E,
                                                    (byte)0x0F, (byte)0x10, (byte)0x11, (byte)0x12,
                                                    (byte)0x13, (byte)0x14, (byte)0x15, (byte)0x16,
                                                    (byte)0x17, (byte)0x18, (byte)0x19, (byte)0x1A,
                                                    (byte)0x1B, (byte)0x1C, (byte)0x1D, (byte)0x1E,
                                                    (byte)0x1F, (byte)0x20, (byte)0x21, (byte)0x22,
                                                    (byte)0x23, (byte)0x24, (byte)0x25, (byte)0x26,
                                                    (byte)0x27, (byte)0x28, (byte)0x29, (byte)0x2A,
                                                    (byte)0x2B, (byte)0x2C, (byte)0x2D, (byte)0x2E,
                                                    (byte)0x2F, (byte)0x30, (byte)0x31, (byte)0x32,
                                                    (byte)0x33, (byte)0x34, (byte)0x35, (byte)0x36,
                                                    (byte)0x37, (byte)0x38, (byte)0x39, (byte)0x3A,
                                                    (byte)0x3B, (byte)0x3C, (byte)0x3D, (byte)0x3E,
                                                    (byte)0x3F, (byte)0x40, (byte)0x41, (byte)0x42};
                        result|=uenvHdlr.compareValue((short)0,cbpage,(short)0,(short)cbpage.length);

                        //content of EnvelopeHanlder shall be the same just like the beginning
                        comparebuffer2=new byte[(short)uenvHdlr.getLength()];
                        uenvHdlr.copy(comparebuffer2,(short)0,(short)uenvHdlr.getLength());
                        result |= Util.arrayCompare(comparebuffer1,(short)0,comparebuffer2,(short)0,(short)comparebuffer2.length);
                        if (result==(byte)0x00){bRes=true;}
                    }
                    reportTestOutcome(testCaseNb,bRes);
                break;
                //--------------------------------------------------------
                //TC 6
                //--------------------------------------------------------
                case EVENT_MO_SHORT_MESSAGE_CONTROL_BY_SIM:
                    testCaseNb=(byte)0x06;
                    result=(byte)0x00; //
                    //copy content of envelope handler to buffer
                    comparebuffer1 = new byte[uenvHdlr.getLength()];
                    uenvHdlr.copy(comparebuffer1,(short)0,uenvHdlr.getLength());
                    if( uenvHdlr.findTLV(TAG_ADDRESS,(byte)0x01)!=TLV_NOT_FOUND){
                        sendDisplayText();
                        byte address[]= new byte[]{(byte)0x81, (byte)0x33, (byte)0x22, (byte)0x55,
                                                   (byte)0x11};
                        result|=uenvHdlr.compareValue((short)0,address,(short)0,(short)address.length);
                        //content of EnvelopeHanlder shall be the same just like the beginning
                        comparebuffer2=new byte[(short)uenvHdlr.getLength()];
                        uenvHdlr.copy(comparebuffer2,(short)0,(short)uenvHdlr.getLength());
                        result |= Util.arrayCompare(comparebuffer1,(short)0,comparebuffer2,(short)0,(short)comparebuffer2.length);
                        if (result==(byte)0x00){bRes=true;}
                    }
                    reportTestOutcome(testCaseNb,bRes);
                    break;
                //--------------------------------------------------------
                //TC 7
                //--------------------------------------------------------
                case EVENT_FORMATTED_SMS_CB:
                    testCaseNb=(byte)0x07;
                    result=(byte)0x00; //
                    //copy content of envelope handler to buffer
                    comparebuffer1 = new byte[uenvHdlr.getLength()];
                    uenvHdlr.copy(comparebuffer1,(short)0,uenvHdlr.getLength());
                    if( uenvHdlr.findTLV(TAG_CELL_BROADCAST_PAGE,(byte)0x01)!=TLV_NOT_FOUND){
                        sendDisplayText();
                        byte cbpage[]= new byte[]{  (byte)0xA7, (byte)0x50, (byte)0x10, (byte)0x93,
                                                    (byte)0xF6, (byte)0x11, (byte)0x00, (byte)0x30,
                                                    (byte)0x0D, (byte)0x00, (byte)0x00, (byte)0x00,
                                                    (byte)0x00, (byte)0x50, (byte)0x01, (byte)0x01,
                                                    (byte)0x00, (byte)0x00, (byte)0x00, (byte)0x00,
                                                    (byte)0x00, (byte)0x00, (byte)0x01, (byte)0x02,
                                                    (byte)0x03, (byte)0x04, (byte)0x05, (byte)0x06,
                                                    (byte)0x07, (byte)0x08, (byte)0x09, (byte)0x0A,
                                                    (byte)0x0B, (byte)0x0C, (byte)0x0D, (byte)0x0E,
                                                    (byte)0x0F, (byte)0x10, (byte)0x11, (byte)0x12,
                                                    (byte)0x13, (byte)0x14, (byte)0x15, (byte)0x16,
                                                    (byte)0x17, (byte)0x18, (byte)0x19, (byte)0x1A,
                                                    (byte)0x1B, (byte)0x1C, (byte)0x1D, (byte)0x1E,
                                                    (byte)0x1F, (byte)0x20, (byte)0x21, (byte)0x22,
                                                    (byte)0x23, (byte)0x24, (byte)0x25, (byte)0x26,
                                                    (byte)0x27, (byte)0x28, (byte)0x29, (byte)0x2A,
                                                    (byte)0x2B, (byte)0x2C, (byte)0x2D, (byte)0x2E,
                                                    (byte)0x2F, (byte)0x30, (byte)0x31, (byte)0x32,
                                                    (byte)0x33, (byte)0x34, (byte)0x35, (byte)0x36,
                                                    (byte)0x37, (byte)0x38, (byte)0x39, (byte)0x3A,
                                                    (byte)0x3B, (byte)0x3C, (byte)0x3D, (byte)0x3E,
                                                    (byte)0x3F, (byte)0x40, (byte)0x41, (byte)0x42};
                        result|=uenvHdlr.compareValue((short)0,cbpage,(short)0,(short)cbpage.length);

                        //content of EnvelopeHanlder shall be the same just like the beginning
                        comparebuffer2=new byte[(short)uenvHdlr.getLength()];
                        uenvHdlr.copy(comparebuffer2,(short)0,(short)uenvHdlr.getLength());
                        result |= Util.arrayCompare(comparebuffer1,(short)0,comparebuffer2,(short)0,(short)comparebuffer2.length);
                        if (result==(byte)0x00){bRes=true;}
                    }
                    reportTestOutcome(testCaseNb,bRes);
                    break;
                //--------------------------------------------------------
                //
                //--------------------------------------------------------
                case EVENT_CALL_CONTROL_BY_NAA:
                    //check the content of the envelope handler
                    //shall contain: DEVICE_ID,ADDRESS and LOCATION INFORMATION TLVs
                    //82 02 82 81   86 02 81 01   93 07 81 F2 A3 34 05 76 67
                    uenvHdlr.copy(comparebuffer2,(short)0,(short)uenvHdlr.getLength());
                    result |= Util.arrayCompare(comparebuffer2,(short)0,naa_value,(short)0,(short)naa_value.length);
                    //tag dev_id shall be selectable
                    if (uenvHdlr.findTLV(TAG_DEVICE_IDENTITIES,(byte)0x01)==TLV_NOT_FOUND) {
                        result=(byte)0xFF;
                    }
                break; //EVENT_CALL_CONTROLL_BY_NAA

            }

        }
        //no exceptions shall be thrown during the test
        catch(Exception ex){
            bRes=false;
            reportTestOutcome(testCaseNb,bRes);
        }


    }//end processToolkit method

    /**
     * Sends a display text
     */
    private void sendDisplayText(){
        ProactiveHandler proHdlr = ProactiveHandlerSystem.getTheHandler();
        proHdlr.initDisplayText((byte)0x80,(byte)0x04,disptextbuffer,(short)0x00,(short)disptextbuffer.length);
        proHdlr.send();
    }

}//end of class Ufw_Hin_Prhd_1