//-----------------------------------------------------------------------------
//Test_Ufw_Mha_Pahd.java
//-----------------------------------------------------------------------------

//-----------------------------------------------------------------------------
//Package Definition
//-----------------------------------------------------------------------------
package uicc.usim.test.usatframework.ufw_mha_pahd;

//-----------------------------------------------------------------------------
//Imports
//-----------------------------------------------------------------------------
import org.etsi.scp.wg3.uicc.jcapi.userinterface.*;
import org.etsi.scp.wg3.uicc.jcapi.userclass.*;
import org._3gpp.ct.wg6.usim.jcapi.userclass.*;
import org._3gpp.ct.wg6.usim.jcapi.userinterface.*;

public class Test_Ufw_Mha_Pahd extends UiccTestModel {


    static final String CAP_FILE_PATH = "uicc/usim/test/usatframework/ufw_mha_pahd";
    private final String CLASS_AID_1 = "A0000000 871005FF FFFFFF89 50010001";
    private final String APPLET_AID_1 = "A0000000 871005FF FFFFFF89 50010102";
    
    private final String CLASS_AID_2 = "A0000000 871005FF FFFFFF89 50020001";
    private final String APPLET_AID_2 = "A0000000 871005FF FFFFFF89 50020102";

  
    private static String     TERMINAL_PROFILE  = "1E09";
  
  
    private USimAPITestCardService test;
   
    /** contains the response from the executed command */
    private APDUResponse      response      = null;
    /** stores the test result */
    private boolean         result      = false;

  /**
   * 
   */
    public Test_Ufw_Mha_Pahd() {
        test = USimAPITestCardService.getTheUSimTestCardService();
    }
    /**
     * Installs the applet, runs the tests and checks the test result.
     */
    public boolean run(){
        // test script
        test.reset();
        test.terminalProfileSession(TERMINAL_PROFILE);
  
        // Install Applet
        test.loadPackage(CAP_FILE_PATH);
        test.installApplet(CAP_FILE_PATH, CLASS_AID_1, APPLET_AID_1, 
                                "8008" + // TLV UICC Toolkit application specific parameters
                                "01" +   // V Priority Level
                                "00" +   // V Max. number of timers
                                "00" +   // V Maximum text length for a menu entry
                                "00" +   // V Maximum number of menu entries                              
                                "00" +   // V Maximum number of channels 
                                "00" +   // LV Minimum Security Level field
                                "00" +   // LV TAR Value(s) 
                                "00" );  // V Maximum number of services                                    
      
        test.installApplet(CAP_FILE_PATH, CLASS_AID_2, APPLET_AID_2, 
                                "8008" + // TLV UICC Toolkit application specific parameters
                                "02" +   // V Priority Level
                                "00" +   // V Max. number of timers
                                "00" +   // V Maximum text length for a menu entry
                                "00" +   // V Maximum number of menu entries                              
                                "00" +   // V Maximum number of channels 
                                "00" +   // LV Minimum Security Level field
                                "00" +   // LV TAR Value(s) 
                                "00" );  // V Maximum number of services              
        
        
        // 1- Send envelope Event Formatted SMS PP ENV to trigger Applet1 
        response = test.envelopeSmsPp("8B254008 81556677 887FF600 11291200" +
                                      "00041402 7000000F 0D080000 00500101" +
                                      "00000000 010001"); 
        result = response.checkSw("9000");          
       
        // 2- Send envelope Event Formatted SMS PP UPD to trigger Applet1
        
        //select EF SMS
        test.selectFile("3F00");//Select MF
        test.selectFile("7F10");//Select DF Telecom
        test.selectFile("6F3C");//Select EF SMS
        //update first record
        response = test.updateRecord("01", "04", "03028100 40088155 6677887F F6001129" +
                                     "12000004 14027000 000F0D00 00000050" +     
                                     "01010000 00000100 01FFFFFF FFFFFFFF" +     
                                     "FFFFFFFF FFFFFFFF FFFFFFFF FFFFFFFF" +     
                                     "FFFFFFFF FFFFFFFF FFFFFFFF FFFFFFFF" +     
                                     "FFFFFFFF FFFFFFFF FFFFFFFF FFFFFFFF" +     
                                     "FFFFFFFF FFFFFFFF FFFFFFFF FFFFFFFF" +     
                                     "FFFFFFFF FFFFFFFF FFFFFFFF FFFFFFFF" +     
                                     "FFFFFFFF FFFFFFFF FFFFFFFF FFFFFFFF" +     
                                     "FFFFFFFF FFFFFFFF FFFFFFFF FFFFFFFF" +     
                                     "FFFFFFFF FFFFFFFF FFFFFFFF FFFFFFFF"); 
        result &= response.checkSw("9000");    


        // 3- Send envelope Event Unformatted SMS PP ENV to trigger Applet1 and Applet2
        response = test.envelopeSmsPp("8B110008 81556677 887FF600 11291200" + 
                                      "000400");
        result &= response.checkSw("9000");  
   

        // 4- Send envelope Event Unformatted SMS PP UPD to trigger Applet1 and Applet2
        
        //select EF SMS
        test.selectFile("3F00");//Select MF
        test.selectFile("7F10");//Select DF Telecom
        test.selectFile("6F3C");//Select EF SMS
        //update second record
        response = test.updateRecord("02", "04", "03028100 00088155 6677887F F6001129" +
                                     "12000004 10AAAAAA AAAAAAAA AAAAAAAA" +     
                                     "AAAAAAAA AAFFFFFF FFFFFFFF FFFFFFFF" +     
                                     "FFFFFFFF FFFFFFFF FFFFFFFF FFFFFFFF" +     
                                     "FFFFFFFF FFFFFFFF FFFFFFFF FFFFFFFF" +     
                                     "FFFFFFFF FFFFFFFF FFFFFFFF FFFFFFFF" +     
                                     "FFFFFFFF FFFFFFFF FFFFFFFF FFFFFFFF" +     
                                     "FFFFFFFF FFFFFFFF FFFFFFFF FFFFFFFF" +     
                                     "FFFFFFFF FFFFFFFF FFFFFFFF FFFFFFFF" +     
                                     "FFFFFFFF FFFFFFFF FFFFFFFF FFFFFFFF" +     
                                     "FFFFFFFF FFFFFFFF FFFFFFFF FFFFFFFF"); 
         result &= response.checkSw("9000");          
        
        

        // 5- Send envelope Event Unformatted SMS CB to trigger Applet1 and Applet2
        response = test.envelopeCellBroadcast("8C58C011 1000F611 00000000 00000000" +
                                              "00000000 00000000 00000000 00000000" +
                                              "00000000 00000000 00000000 00000000" +
                                              "00000000 00000000 00000000 00000000" +
                                              "00000000 00000000 00000000 00000000" +
                                              "00000000 00000000 0000"); 
        result &= response.checkSw("9000");          
                
        
        // 6- Send envelope Event Mo Short Message Control by Sim to trigger Applet1
        response = test.envelopeMoShortMessageControl();
        result &= response.checkSw("9000");      

                                                                                
        // 7- Send envelope Event Formatted SMS CB to trigger Applet1 
        response = test.envelopeCellBroadcast("8C58A750 1093F611 000F0D00 00000050"
                                            + "01010000 00000100 01000000 00000000"
                                            + "00000000 00000000 00000000 00000000"
                                            + "00000000 00000000 00000000 00000000"
                                            + "00000000 00000000 00000000 00000000"
                                            + "00000000 00000000 0000");
        result &= response.checkSw("9000");
  

        test.reset();
        //    NO Terminal Profile is sent

        // 8- Send envelope Event Formatted SMS PP ENV to trigger Applet1 
        response = test.envelopeSmsPp("8B254008 81556677 887FF600 11291200" +
                                      "00041402 7000000F 0D080000 00500101" +
                                      "00000000 010001"); 
                 
       
        // 9- Send envelope Event Formatted SMS PP UPD to trigger Applet1
        
        //select EF SMS
        test.selectFile("3F00");//Select MF
        test.selectFile("7F10");//Select DF Telecom
        test.selectFile("6F3C");//Select EF SMS
        //update first record
        response = test.updateRecord("01", "04", "03028100 40088155 6677887F F6001129" +
                                     "12000004 14027000 000F0D00 00000050" +     
                                     "01010000 00000100 01FFFFFF FFFFFFFF" +     
                                     "FFFFFFFF FFFFFFFF FFFFFFFF FFFFFFFF" +     
                                     "FFFFFFFF FFFFFFFF FFFFFFFF FFFFFFFF" +     
                                     "FFFFFFFF FFFFFFFF FFFFFFFF FFFFFFFF" +     
                                     "FFFFFFFF FFFFFFFF FFFFFFFF FFFFFFFF" +     
                                     "FFFFFFFF FFFFFFFF FFFFFFFF FFFFFFFF" +     
                                     "FFFFFFFF FFFFFFFF FFFFFFFF FFFFFFFF" +     
                                     "FFFFFFFF FFFFFFFF FFFFFFFF FFFFFFFF" +     
                                     "FFFFFFFF FFFFFFFF FFFFFFFF FFFFFFFF"); 
        


        // 10- Send envelope Event Unformatted SMS PP ENV to trigger Applet1 and Applet2
        response = test.envelopeSmsPp("8B110008 81556677 887FF600 11291200" + 
                                      "000400");
        
   

        // 11- Send envelope Event Unformatted SMS PP UPD to trigger Applet1 and Applet2
        
        //select EF SMS
        test.selectFile("3F00");//Select MF
        test.selectFile("7F10");//Select DF Telecom
        test.selectFile("6F3C");//Select EF SMS
        //update second record
        response = test.updateRecord("02", "04", "03028100 00088155 6677887F F6001129" +
                                     "12000004 10AAAAAA AAAAAAAA AAAAAAAA" +     
                                     "AAAAAAAA AAFFFFFF FFFFFFFF FFFFFFFF" +     
                                     "FFFFFFFF FFFFFFFF FFFFFFFF FFFFFFFF" +     
                                     "FFFFFFFF FFFFFFFF FFFFFFFF FFFFFFFF" +     
                                     "FFFFFFFF FFFFFFFF FFFFFFFF FFFFFFFF" +     
                                     "FFFFFFFF FFFFFFFF FFFFFFFF FFFFFFFF" +     
                                     "FFFFFFFF FFFFFFFF FFFFFFFF FFFFFFFF" +     
                                     "FFFFFFFF FFFFFFFF FFFFFFFF FFFFFFFF" +     
                                     "FFFFFFFF FFFFFFFF FFFFFFFF FFFFFFFF" +     
                                     "FFFFFFFF FFFFFFFF FFFFFFFF FFFFFFFF"); 
           
        
        

        // 12- Send envelope Event Unformatted SMS CB to trigger Applet1 and Applet2
        response = test.envelopeCellBroadcast("8C58C011 1000F611 00000000 00000000" +
                                              "00000000 00000000 00000000 00000000" +
                                              "00000000 00000000 00000000 00000000" +
                                              "00000000 00000000 00000000 00000000" +
                                              "00000000 00000000 00000000 00000000" +
                                              "00000000 00000000 0000"); 
                  
                
        
        // 13- Send envelope Event Mo Short Message Control by Sim to trigger Applet1
        response = test.envelopeMoShortMessageControl();
             

                                                                                
        // 14- Send envelope Event Formatted SMS CB to trigger Applet1 
        response = test.envelopeCellBroadcast("8C58A750 1093F611 000F0D00 00000050"
                                            + "01010000 00000100 01000000 00000000"
                                            + "00000000 00000000 00000000 00000000"
                                            + "00000000 00000000 00000000 00000000"
                                            + "00000000 00000000 00000000 00000000"
                                            + "00000000 00000000 0000");
        


        
        response = test.selectApplication(APPLET_AID_1);
        // For test cases from 8 to 14 applet may not be triggered. 
        // If no Terminal profile is sent applet may be triggered or not
        result &=  (response.checkData("10" +APPLET_AID_1 +
                          "0ECCCCCC CCCCCCCC CCCCCCCC CCCCCC") || 
                    response.checkData("10" +APPLET_AID_1 +
                          "09CCCCCC CCCCCCCC CCCC"));
        response = test.selectApplication(APPLET_AID_2);
        result &=  (response.checkData("10" +APPLET_AID_2 +
                          "06CCCCCC CCCCCC") ||
                    response.checkData("10" +APPLET_AID_2 +
                          "04CCCCCC CC"));  
      
        //  delete applet and package
        test.reset();
        test.terminalProfileSession(TERMINAL_PROFILE);
        test.deleteApplet(APPLET_AID_1);
        test.deleteApplet(APPLET_AID_2);
        
        test.deletePackage(CAP_FILE_PATH);
          
        return result;
  }
  
  
}