//-----------------------------------------------------------------------------
//Ufw_Tin_Acdo_1.java
//-----------------------------------------------------------------------------

//-----------------------------------------------------------------------------
//Package Definition
//-----------------------------------------------------------------------------
package uicc.usim.test.usatframework.ufw_tin_acdo;

import javacard.framework.*;
import uicc.access.*;
import uicc.test.util.UICCTestConstants;
import uicc.toolkit.ToolkitConstants;
import uicc.usim.test.util.*;
import uicc.usim.toolkit.USATEnvelopeHandler;
import uicc.usim.toolkit.USATEnvelopeHandlerSystem;

//-----------------------------------------------------------------------------
//Imports
//-----------------------------------------------------------------------------

/**
 * Test Area : uicc.usim.test.usatframework.ufw_tin_acdo
 *
 * @version 0.0.1 - 15 sept. 2005
 * @author 3GPP T3 SWG API
 */
public class Ufw_Tin_Acdo_1 extends TestToolkitApplet implements uicc.usim.toolkit.ToolkitConstants
{
    // Number of tests
    byte testCaseNb = (byte) 0x01;
    
    private FileView theUiccView;
    
    byte[] incr = new byte[6];
    byte[] resp = new byte[6];
    short incrOffset = 0;
    short incrLength = 1;
    short respOffset = 0;
   
    /**
    * Constructor of the applet
    */
    public Ufw_Tin_Acdo_1 () 
    {
    }
    
    
    /**
    * Method called by the JCRE at the installation of the applet
    */
    public static void install(byte bArray[], short bOffset, byte bLength) 
    {
        // Create a new applet instance
        Ufw_Tin_Acdo_1  thisApplet = new Ufw_Tin_Acdo_1 ();
        
        // Register the new applet instance to the JCRE            
        thisApplet.register(bArray, (short)(bOffset+1), bArray[bOffset]);
        
        // Initialise the data of the test applet
        thisApplet.init(); 
        
        //register to EVENT_UNRECOGNIZED_ENVELOPE
        thisApplet.obReg.setEvent(ToolkitConstants.EVENT_UNRECOGNIZED_ENVELOPE);
    }
    
    
    /**
     * Method called by the SIM Toolkit Framework
    */
    public void processToolkit(short event) 
    {
        
        boolean bRes = false;
        byte[] data = new byte[1];
        
        theUiccView = UICCSystem.getTheUICCView (JCSystem.CLEAR_ON_RESET);

        // Get the system instance of the EnvelopeHandler class
        USATEnvelopeHandler envHdlr = USATEnvelopeHandlerSystem.getTheHandler();
        envHdlr.findTLV((byte)0xDA,(byte)0x01);
        
        switch (envHdlr.getValueByte((short)0)){
            
            case (byte)0x01:
                testCaseNb = (byte)0x01;
                theUiccView.select(UICCTestConstants.FID_DF_TEST);
                theUiccView.select(UICCTestConstants.FID_EF_CUAC);
                try 
                {
                    theUiccView.increase(incr, incrOffset, incrLength, resp, respOffset);
                    bRes = true;
                }
                catch (Exception e)
                {
                    bRes = false;
                }
                reportTestOutcome(testCaseNb, bRes);
                break;
                
            case (byte)0x02:
                testCaseNb = (byte)0x01;
                reportTestOutcome(testCaseNb, true);
                theUiccView.select(UICCTestConstants.FID_DF_TEST);
                theUiccView.select(UICCTestConstants.FID_EF_TARU);
                data[0] = (byte)0x01;
                testCaseNb++;
                try 
                {
                    theUiccView.updateBinary((short)0,data,(short)0,(short)data.length);
                }
                catch (UICCException e)
                {
                    if (e.getReason() == (short)UICCException.SECURITY_STATUS_NOT_SATISFIED)
                        bRes = true;
                    else
                        bRes = false;
                }
                catch (Exception e)
                {
                    bRes = false;
                }
                reportTestOutcome(testCaseNb, bRes);
                break;
                
            case (byte)0x03:
                testCaseNb = (byte)0x01;
                reportTestOutcome(testCaseNb, true);
                theUiccView.select(UICCTestConstants.FID_DF_TEST);
                theUiccView.select(UICCTestConstants.FID_EF_TARU);
                data[0] = (byte)0xFF;
                testCaseNb++;
                try 
                {
                    theUiccView.updateBinary((short)0,data,(short)0,(short)data.length);
                    bRes = true;
                }
                catch (UICCException e)
                {
                    bRes = false;
                }
                catch (Exception e)
                {
                    bRes = false;
                }
                reportTestOutcome(testCaseNb, bRes);
                
                testCaseNb++;
                theUiccView.select(UICCTestConstants.FID_EF_TNU);
                try 
                {
                    theUiccView.updateBinary((short)0,data,(short)0,(short)data.length);
                }
                catch (UICCException e)
                {
                    if (e.getReason() == (short)UICCException.SECURITY_STATUS_NOT_SATISFIED)
                        bRes = true;
                    else
                        bRes = false;
                }
                catch (Exception e)
                {
                    bRes = false;
                }
                reportTestOutcome(testCaseNb, bRes);
                break;
                        
            default:
                reportTestOutcome((byte)testCaseNb, false);
                testCaseNb++;
                break;              
        }           
    }
} 